/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ I N C L U D E S \\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
#include "eazy_gem.h"

/* end of include...................................................... */

extern void BoucleModale(EVNT_O *evnt_o, 
                         CALLBACK (*Menu_proc)(INT16 w_ind, EVNT_O *Evnt));
extern INT16 DrawEditableCursor(OBJECT *object, INT16 ind, INT16 poscur);

extern INT16 ToolTipDel(INT16 w_h,INT16 type, INT16 nbr, void *ptr);
extern INT16 ToolTipAdd(INT16 w_h,INT16 type, INT16 nbr, void *ptr);
extern INT16 Event_dispatch(EVNT_O *evnt_o, CALLBACK (*Men_proc)(INT16 wind, EVNT_O *Evnt)); 
extern INT16 FindObTypeInParentAndFreres(OBJECT *object, INT16 ob, INT16 ob_type);
extern INT16 FindVerticalBarGadget(OBJECT *object, INT16 ob_scroll, INT16 *ob_Vasc);
extern INT16 FindHorizontalBarGadget(OBJECT *object, INT16 ob_scroll, INT16 *ob_Hasc);
extern INT16 GetFrameWidth(OBJECT *object, INT16 ind);

/*................ fonctions internes non publiques ...................*/
void    GrectMove(GRECT *grect);
void    GetEvntNames(char *buft, INT16 evnt);
void    Rc_copy( INT16 xs, INT16 ys, INT16 ws, INT16 hs, INT16 xd, INT16 yd);
void    DirectRedrawMessage(INT16 w_ind, GRECT * scrol_grect, GRECT *update_grect, void *param);
void   *EZB_OpenFormFic(INT16 w_ind, OBJECT *ob_script);
INT16     EZB_CloseFormFic(EZB_FIC_STRUCT *EZB_STRUCT);
long    EZB_Init_CHPSTRUCT( INT16 w_ind, EZB_FIC_STRUCT *EZB_STRUCT, INT16 fic, char *fic_def);
OBJECT *EZB_GetFormScriptLink(INT16 w_ind);
OBJECT *EZB_GetScriptContainer(INT16 w_ind, char *scriptlink);
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*                A   C O M M E N C E   I C I   !!!!                   */
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

/*------------------------ GetTopWind ----------------------------------*/
/* ACTION: retourne le handle de la fenetre en avant plan.              */
/* ENTREE: Neant.                                                       */
/* RETOUR:  handle de la fenetre en avant plan.                         */

INT16 GetTopWind(void)
{INT16 wh_top, d;                    /* handle fenetre en avant plan    */
 wind_get( 0, WF_TOP, &wh_top, &d,&d,&d); /* recuperer handle fen. avt plan.      */
 return wh_top;
}
 
/*------------------------ FlyGrect ------------------------------------*/
/* ACTION: Deplace un rectangle Bit map, d'ecran ou son fantome (selon  */
/*         valeur du flag: flag),  l'aide de la souris. La main est    */
/*         rendue apres relachage de la souris, ou appui d'une touche   */
/*         clavier.                                                     */
/* ENTREE: GRECT *grect: pointe sur le rectangle  deplacer sur l'ecran */
/*         INT16 x, INT16 y: position x et y de la souris lors de       */
/*                       l'appel  la fonction.                         */
/*         INT16 flag: BIT0 1/mode bit map-> il est deplace  l'ecran   */
/*                                 le bout d'ecran represente par le    */
/*                                 rectangle: grect.                    */
/*                          0/mode fantome il est deplace  l'ecran un  */
/*                                 cadre fantome represente par grect   */
/*                                                                      */
/*                     BIT1 0/  deplacement en X evalue                 */
/*                          1/  deplacement en X non evalue             */
/*                     BIT2 0/  deplacement en Y evalue                 */
/*                          1/  deplacement en Y non evalue             */
/*                                                                      */
/* RETOUR: zro:           le retour s'est fait par relachage de la     */
/*                         souris.                                      */
/*         different de 0: le retour se fait apres appui d'une touche   */
/*                         clavier qui est retournee:                   */
/*                         (meme format que evnt_multi() CAD:           */
/*                                   poids fort   = scan code           */
/*                                   poids faible = code ASCII          */
/*         -1              erreur (generalement memoire insuffisante)   */

INT16 FlyGrect(GRECT *grect, INT16 x, INT16 y, INT16 flag)
{void *flyBuff;
 Clip (0, 0, Ecran_l, Ecran_h);
 flyBuff = Flysave(VDIhandle, grect->g_x, grect->g_y, grect->g_w, grect->g_h);
 if (flyBuff)        /* si l'initialisation s'est passee correctement    */
   {INT16 dx     = x;  /* initialiser la position de la souris en X        */
    INT16 dy     = y;  /* initialiser la position de la souris en Y        */
    /*....... deplacer le rectangle  l'aide de la souris ...............*/
    /* Si le dernier parametre est  1 c'est le bitmap ecran situe sous  */
    /*                          le rectangle qui est deplace.            */
    /* Si le dernier parametre  est  0 c'est juste un rectangle fantome */
    /*                          qui est deplace.                         */
 
    INT16 key = FlyFly( &flyBuff, &dx, &dy, flag);
    Flyrestore(flyBuff); /* liberer le buffer et restaurer l'ecran       */
    return key;
   }
 return -1;
}

/*------------------------ Intersect -----------------------------------*/
/* ACTION: retourne le rectangle intersectant de deux rectangles        */
/* ENTREE: INT16  x1,INT16  y1,INT16  w1,INT16  h1: premier rectangle           */
/*         INT16  x2,INT16  y2,INT16  w2,INT16  h2: deuxime rectangle          */
/*         INT16 *x3,INT16 *y3,INT16 *w3,INT16 *h3: rectangle resultant         */
/* RETOUR: 1/si intersection, 0/si pas d'intersection,                  */

INT16  Intersect(INT16  x1,INT16  y1,INT16  w1,INT16  h1,
               INT16  x2,INT16  y2,INT16  w2,INT16  h2,
               INT16 *x3,INT16 *y3,INT16 *w3,INT16 *h3)
{*x3 = Max(x1,x2);
 *y3 = Max(y1,y2);
 *w3 = Min(x1+w1-1,x2+w2-1) - *x3 + 1;
 *h3 = Min(y1+h1-1,y2+h2-1) - *y3 + 1;
 return ((*w3 > 0) && (*h3 > 0));
}

/*---------------------- Flysave ----------------------------------------*/
/* ACTION: cree et sauve dans un buffer le fond du rectangle  deplacer  */
/*         tout en initialisant les donnes pour deplacement.            */
/* ENTREE: INT16 vdihandle: handle VDI de la station de trvail graphique.  */
/*         INT16 x,INT16 y,INT16 w,INT16 h: coordonnes du rectangle.            */
/* SORTIE: void *: un pointeur sur une structure de type: FLYBUFF        */
/*                  zero si erreur.                                      */

void    *Flysave(INT16 vdihandle,INT16 x,INT16 y,INT16 w,INT16 h)
{FLYBUFF  *fly_buff;
 long   size = Blk_size(w,h,Nb_plan);
 INT16 wdwidth = (INT16)((w + 15) / 16);
 if ((fly_buff = (FLYBUFF*)malloc(size + sizeof(FLYBUFF))) == 0)
        return(0);
 else
   {fly_buff->magic = 0x4711;
    fly_buff->vdihandle       = vdihandle;
    fly_buff->mfdb.fd_addr    = &fly_buff->data;
    fly_buff->mfdb.fd_w       = w;
    fly_buff->mfdb.fd_h       = h;
    fly_buff->mfdb.fd_wdwidth = wdwidth;
    fly_buff->mfdb.fd_stand   = 0;
    fly_buff->mfdb.fd_nplanes = Nb_plan;
    fly_buff->scr.fd_addr     = Screen_MFDB.fd_addr;
    fly_buff->scr.fd_w        = Screen_MFDB.fd_w;
    fly_buff->scr.fd_h        = Screen_MFDB.fd_h;
    fly_buff->scr.fd_wdwidth  = Screen_MFDB.fd_wdwidth;
    fly_buff->scr.fd_stand    = Screen_MFDB.fd_stand;
    fly_buff->scr.fd_nplanes  = Screen_MFDB.fd_nplanes;
    fly_buff->pxy[0]          = x;
    fly_buff->pxy[1]          = y;
    fly_buff->pxy[2]          = x + w - 1;
    fly_buff->pxy[3]          = y + h - 1;
    fly_buff->pxy[4]          = 0;
    fly_buff->pxy[5]          = 0;
    fly_buff->pxy[6]          = w-1;
    fly_buff->pxy[7]          = h-1;
    Mouse_off();
    vro_cpyfm(vdihandle,S_ONLY,fly_buff->pxy, &fly_buff->scr,&fly_buff->mfdb);
    /*   Mouse_on();  */
    return(fly_buff);
   }
}

/*---------------------- Flyrestore --------------------------------*/
/* ACTION: restitue le fond apres dernier deplacement et libere la  */
/*         memoire alouee pendant l'operation.                      */
/* ENTREE: void *fly_buff: pointeur sur structure de type: FLYBUFF  */
/* SORTIE: Neant                                                    */

void    Flyrestore(void *fly_buff)
{
 #define fly_buff  ((FLYBUFF *)fly_buff)
 INT16     pxy[8];
 INT16     *s,*d;
 if (fly_buff != 0 && fly_buff->magic == 0x4711) 
    {fly_buff->magic = 0;
     d = pxy; s = fly_buff->pxy+4;
     *d++ = *s++; *d++ = *s++; *d++ = *s++; *d++ = *s++;
     d = pxy+4; s = fly_buff->pxy;
     *d++ = *s++; *d++ = *s++; *d++ = *s++; *d++ = *s++;
     Mouse_off();
     vro_cpyfm(fly_buff->vdihandle,S_ONLY,pxy,
               &fly_buff->mfdb,&fly_buff->scr);
     /*  Mouse_on();  */
     free(fly_buff); 
    }
 return;
 #undef  fly_buff
}

/*------------------------ Scrmove ---------------------------------*/
/* ACTION: deplace un rectngle  l'ecran tout en restituant le fond */
/* ENTREE: void *fly_buff: pointeur sur structure de type: FLYBUFF  */
/*         INT16 nx,INT16 ny: quantit en X et Y du deplacement        */
/* SORTIE: void *: pointeur sur structure FLYBUFF (peut changer)    */

void     *Scrmove(void *fly_buff, INT16 nx,INT16 ny)
{
 #define fly_buff  ((FLYBUFF *)fly_buff)
 FLYBUFF  *newbuffer;
 INT16     w,h;
 INT16     rx,ry,rw,rh;
 INT16     pxy[8],rst[8];
 if (fly_buff != 0 && fly_buff->magic == 0x4711) 
    {Mouse_off();
     w = fly_buff->pxy[2]-fly_buff->pxy[0]+1;
     h = fly_buff->pxy[3]-fly_buff->pxy[1]+1;
     newbuffer = (FLYBUFF*) Flysave(fly_buff->vdihandle,nx,ny,w,h);
     if (newbuffer == 0) 
        {form_dial(FMD_FINISH,0,0,0,0,nx,ny,w,h);
         Flyrestore(fly_buff);
         return(0); 
        }
     Mouse_off();
     fly_buff->magic = 0;
     pxy[0] = fly_buff->pxy[0];
     pxy[1] = fly_buff->pxy[1];
     pxy[2] = fly_buff->pxy[2];
     pxy[3] = fly_buff->pxy[3];
     pxy[6] = (pxy[4] = nx) + w - 1;
     pxy[7] = (pxy[5] = ny) + h - 1;
     if (Intersect(pxy[0],pxy[1],w,h, pxy[4],pxy[5],w,h, &rx,&ry,&rw,&rh)) 
        {rst[2] = (rst[0] = rx - pxy[0]) + rw - 1;
         rst[3] = (rst[1] = ry - pxy[1]) + rh - 1;
         rst[6] = (rst[4] = rx - nx) + rw - 1;
         rst[7] = (rst[5] = ry - ny) + rh - 1;
         vro_cpyfm(fly_buff->vdihandle,S_ONLY,rst,
                   &fly_buff->mfdb,&newbuffer->mfdb); 
        }
     vro_cpyfm(fly_buff->vdihandle,S_ONLY,pxy,&fly_buff->scr,&fly_buff->scr);
     if (Intersect(pxy[0],pxy[1],w,h, 
                   pxy[0],pxy[1],pxy[6]-pxy[0]+1,pxy[5]-pxy[1],
                   &rx,&ry,&rw,&rh)
        ) 
        {rst[2] = (rst[0] = rx - pxy[0]) + rw - 1;
         rst[3] = (rst[1] = ry - pxy[1]) + rh - 1;
         rst[6] = (rst[4] = rx) + rw - 1;
         rst[7] = (rst[5] = ry) + rh - 1;
         vro_cpyfm(fly_buff->vdihandle,S_ONLY,rst,&fly_buff->mfdb,&fly_buff->scr);
        }
     if (Intersect(pxy[0],pxy[1],w,h,
                   pxy[6]+1,pxy[1],pxy[2]-pxy[6],pxy[7]-pxy[1]+1,
                   &rx,&ry,&rw,&rh)
        )
        {rst[2] = (rst[0] = rx - pxy[0]) + rw - 1;
         rst[3] = (rst[1] = ry - pxy[1]) + rh - 1;
         rst[6] = (rst[4] = rx) + rw - 1;
         rst[7] = (rst[5] = ry) + rh - 1;
         vro_cpyfm(fly_buff->vdihandle,S_ONLY,rst,&fly_buff->mfdb,&fly_buff->scr);
        }
     if (Intersect(pxy[0],pxy[1],w,h,
                   pxy[4],pxy[7]+1,pxy[2]-pxy[4]+1,pxy[3]-pxy[7],
                   &rx,&ry,&rw,&rh)
        )
        {rst[2] = (rst[0] = rx - pxy[0]) + rw - 1;
         rst[3] = (rst[1] = ry - pxy[1]) + rh - 1;
         rst[6] = (rst[4] = rx) + rw - 1;
         rst[7] = (rst[5] = ry) + rh - 1;
         vro_cpyfm(fly_buff->vdihandle,S_ONLY,rst,&fly_buff->mfdb,&fly_buff->scr);
        }
     if (Intersect(pxy[0],pxy[1],w,h,
                   pxy[0],pxy[5],pxy[4]-pxy[0],pxy[3]-pxy[5]+1,
                   &rx,&ry,&rw,&rh)
        )
        {rst[2] = (rst[0] = rx - pxy[0]) + rw - 1;
         rst[3] = (rst[1] = ry - pxy[1]) + rh - 1;
         rst[6] = (rst[4] = rx) + rw - 1;
         rst[7] = (rst[5] = ry) + rh - 1;
         vro_cpyfm(fly_buff->vdihandle,S_ONLY,rst,&fly_buff->mfdb,&fly_buff->scr);
        }
     Mouse_on();
     free(fly_buff);
     return(newbuffer); 
    }
 return(0);
 #undef  fly_buff
}
/*--------------------------- GrectMove --------------------------------*/
void GrectMove(GRECT *grect)
{VRECT vrect;
 GRECT_to_VRECT(grect, &vrect);
 Defline(1,1,0,0,1);
 vsl_udsty(VDIhandle,0x5555);
 vsl_type(VDIhandle,7);
 Graphmode (3);
 Mouse_off();
 Box((INT16*)&vrect);
 Mouse_on(); 
}

/*---------------------------- FlyFly ---------------------------------------*/
/* ACTION: Deplace un rectangle defini par la structure: FLYBUFF tant que la */
/*         souris reste appuyee.                                             */
/* ENTREE: void **fly_buff: pointeur sur un pointeur de structure: FLYBUFF,  */
/*                        cette structure devra auparavant avoir ete         */
/*                        initialisee par la fonction: Flysave().            */
/*         INT16* dx, INT16* dy: pointeur sur les positions initiales de la  */
/*                           souris.                                         */
/*         INT16 flag: BIT0  0/seul un cadre fantome est deplace.            */
/*                           1/le bitmap situe sous le rectangle est deplace */
/*                     BIT1  0/  deplacement en X evalue                     */
/*                           1/  deplacement en X non evalue                 */
/*                     BIT2  0/  deplacement en Y evalue                     */
/*                           1/  deplacement en Y non evalue                 */
/* RETOUR: 0/sortie par relachement  si != 0 touche clavier appuye          */

INT16 FlyFly( void **fly_buff, INT16* dx, INT16* dy, INT16 flag)
{
 #define fly_buff  ((FLYBUFF **)fly_buff)
 INT16       x,y,w,h;
 INT16       orgx,orgy;
 INT16       wx,wy,ww,wh;
 INT16       posx,posy,mx,my,mb,mk,key, nb_c;
 INT16       pipe[16];
 INT16 evnt;
 GRECT grect;
 orgx=x=(*fly_buff)->pxy[0];
 orgy=y=(*fly_buff)->pxy[1];
 w=(*fly_buff)->mfdb.fd_w;
 h=(*fly_buff)->mfdb.fd_h;
 
 /* wind_get(0,WF_WORKXYWH,&wx,&wy,&ww,&wh); */
 wx = 0;
 wy = 0;
 ww = Ecran_l;
 wh = Ecran_h;
 wind_update(BEG_MCTRL);
 if (!(flag&1)) 
    {VRECT_to_GRECT((VRECT*)(*fly_buff)->pxy, &grect);
     GrectMove(&grect);
     *dx = x - orgx;
     *dy = y - orgy;
     graf_mkstate(&mx,&my,&mb,&mk);
     posx = x - mx;
     posy = y - my;
     while (mb>0) 
       {
        #ifndef _GEMLIB_H_
        evnt = evnt_multi(MU_TIMER|MU_KEYBD|MU_BUTTON,
               0x1, 1, 0,            /* button_click,mask,state */
               0, 0,0, 0, 0,         /* inbox xylh              */
               0, 0,0, 0, 0,         /* outbox xylh             */
               pipe,                 /* adr_buffer_mess         */
               25, 0   ,             /* lotimer hitimer         */
               &mx,&my,&mb,&mk,&key,&nb_c);
        #else
        evnt = evnt_multi(MU_TIMER|MU_KEYBD|MU_BUTTON,
               0x1, 1, 0,            /* button_click,mask,state */
               0, 0,0, 0, 0,         /* inbox xylh              */
               0, 0,0, 0, 0,         /* outbox xylh             */
               pipe,                 /* adr_buffer_mess         */
               MAKELONG(0,25),
               &mx,&my,&mb,&mk,&key,&nb_c);
        #endif
        if ( !(evnt&MU_KEYBD) ) key=0;
        graf_mkstate(&mx,&my,&mb,&mk);
        if (!(flag&2)) x = mx + posx;
        if (!(flag&4)) y = my + posy;
        if (x + w > wx + ww) x = wx + ww - w;
        if (x < wx) x = wx;
        if (y + h > wy + wh) y = wy + wh - h;
        if (y < wy) y = wy;
        if (x != grect.g_x || y != grect.g_y)
           {GrectMove(&grect);
            grect.g_x = x;
            grect.g_y = y;
            GrectMove(&grect);
           }
        if (key&0x00FF) mb = -1;    /* mettre fin  la boucle */
       }
     GrectMove(&grect);
     *dx = x - orgx;
     *dy = y - orgy;
    }
 else 
    {graf_mkstate(&mx,&my,&mb,&mk);
     posx = x - mx;
     posy = y - my;
     while (mb>0) 
       {
        #ifndef _GEMLIB_H_
        evnt = evnt_multi(MU_TIMER|MU_KEYBD|MU_BUTTON,
               0x102, 3, 0,          /* button_click,mask,state */
               0, 0,0, 0, 0,         /* inbox xylh              */
               0, 0,0, 0, 0,         /* outbox xylh             */
               pipe,                 /* adr_buffer_mess         */
               25, 0   ,             /* lotimer hitimer         */
               &mx,&my,&mb,&mk,&key,&nb_c);
        #else
        evnt = evnt_multi(MU_TIMER|MU_KEYBD|MU_BUTTON,
               0x102, 3, 0,          /* button_click,mask,state */
               0, 0,0, 0, 0,         /* inbox xylh              */
               0, 0,0, 0, 0,         /* outbox xylh             */
               pipe,                 /* adr_buffer_mess         */
               MAKELONG(0,25),
               &mx,&my,&mb,&mk,&key,&nb_c);
        #endif
        if ( !(evnt&MU_KEYBD) ) key=0;
        graf_mkstate(&mx,&my,&mb,&mk);
        if (!(flag&2)) x = mx + posx;
        if (!(flag&4)) y = my + posy;
        if (x + w > wx + ww) x = wx + ww - w;
        if (x < wx) x = wx;
        if (y + h > wy + wh) y = wy + wh - h;
        if (y < wy) y = wy;
        if ( (*fly_buff)->pxy[0] != x || 
             (*fly_buff)->pxy[1] != y
           )
           {*fly_buff = (FLYBUFF*) Scrmove(*fly_buff,x,y);
           }
        if (key&0x00FF)  mb = -1;    /* mettre fin  la boucle */
       }
     *dx = x - orgx;
     *dy = y - orgy;
    }
 wind_update(END_MCTRL);
 if (mb==-1) return key;
 else        return 0;
 #undef fly_buff
}

/*--------------------------- GetExtension -----------------------------*/
/* ACTION: retourne un pointeur sur l'extension d'un fichier si elle    */
/*         existe. Ce pointeur pointe sur le point. exemple ".DOC"      */
/* ENTREE: char *nom: pointe sur le nom du fichier dont on cherche      */
/*                    l'extension. (peut etre aussi le path complet)    */
/*         char *dst: pointe sur une chaine dans laquelle sera recopiee */
/*                    l'extension (prevoir la place). Si cette valeur   */
/*                    est  zero, il ne sera pas opere de recopie.      */
/* RETOUR: char*: un pointeur sur sur l'extension dans la chaine        */
/*                d'origine. Si zero pas d'extension retrouvee.         */

char *GetExtension(char *nom, char *dst)
{char *pt = strrchr(nom,'.');     /* rechercher le point de NOM.EXT */
 if (pt && dst) 
    {strcpy(dst, pt);
     return pt;
    }
 return pt;
}

/*--------------------------- ObjcGetLenTxt --------------------------------*/
/* ACTION: permet d'obtenir l'adresse de la chaine texte d'un objet.        */
/*         Il est impratif de n'utiliser que cette fonction dans EAZY_GEM  */
/*         pour obtenir l'adresse de la chaine texte des objets.            */
/*         retourne la longueur max de la chaine y compris 0 de fin         */
/* ENTREE: OBJECT *adr, pointe sur l'arbre de l'objet.                      */
/*         INT16 object, indice de l'objet.                                   */
/*         char **txt,  pointe  sur pointeur de chaine qui est placee sur   */
/*                      l'adresse de la chaine de l'objet. Cette valeur     */
/*                      ne pas etre fournie (mise  zero) et alors elle ne  */
/*                      sera pas remplie avec l'adresse de la chaine de     */
/*                      l'objet.                                            */
/* RETOUR: un long indiquant la taille de la chaine y compris le 0 de fin   */

long ObjcGetLenTxt (OBJECT *adr, INT16 object, char **txt)
{
XUSERBLK *xuserblk;
TEDINFO  *tedinfo;
INT16 type;
INT16 ob_xtype;
    
type     =  adr[object].ob_type     & 0x00FF;
ob_xtype = (adr[object].ob_type>>8) & 0x00FF;
    if      ((type == G_STRING) || (type == G_BUTTON))  
            {if (txt) *txt      = adr[object].ob_spec.free_string;
             return  strlen(adr[object].ob_spec.free_string)+1;    /* rajouter zero de fin */
            }
    
    else if (type == G_USERDEF)
            {switch (ob_xtype)
               {
                case G_CICON:
                    {ICONBLK *iconblk  = (ICONBLK *)(adr[object].ob_spec.userblk->ub_parm);
                     if (txt) *txt     = iconblk->ib_ptext;
                     return strlen(iconblk->ib_ptext);
                    }
                case G_FTEXT:
                case G_FBOXTEXT:
                case NEW_BUTTON:
                case RADIO_BUTTON:
                case COCHE_BUTTON:
                case LISTBOX:
                case CADRE_VIDE:
                case GROUP_LITLE:
                case GROUP_LARGE:
                case SCROLL_BOX:
                case USER_SV_UP:
                case USER_SV_DW:
                case USER_SV_AS:
                case USER_SV_BAR:
                case USER_SH_LF:
                case USER_SH_RG:
                case USER_SH_AS:
                case USER_SH_BAR:
                case USER_BMPBOX:
                     xuserblk  = (XUSERBLK*) adr[object].ob_spec.userblk->ub_parm; 
                     tedinfo   = xuserblk->tedinfo;
                     if (txt) *txt      = tedinfo->te_ptext;
                     return  tedinfo->te_txtlen;
#ifdef __TXT_PROC__                                                       
                case SCROLL_EDIT:
                     {TXTED_OB* TXT_A = EZ_ED_GetTxtEditStruct(adr, object);
                      if (TXT_A)                    
                         {EZ_ED_GraphUpdate(TXT_A);
                          if (txt) *txt      = TXT_A->ptTxt;
                          return TXT_A->EndBuff - TXT_A->ptTxt;
                         }
                      else        
                         {xuserblk  = (XUSERBLK*) adr[object].ob_spec.userblk->ub_parm; 
                          tedinfo   = xuserblk->tedinfo;
                          if (txt) *txt      = tedinfo->te_ptext;
                          return  tedinfo->te_txtlen;
                         }
                     }  /* endcase SCROLL_EDIT: */
#endif                 
               }  /* endswitch (ob_xtype)   */
            }
    else if ((type == G_TEXT)    ||
             (type == G_BOXTEXT) ||
             (type == G_FTEXT)   ||
             (type == G_FBOXTEXT)
            )
            {if (txt) *txt      = adr[object].ob_spec.tedinfo->te_ptext;                                       
             return (adr[object].ob_spec.tedinfo->te_txtlen);
            }
   else if  (type==G_ICON)
            {ICONBLK *iconblk  = (ICONBLK *)(adr[object].ob_spec.iconblk);
             if (txt) *txt     = iconblk->ib_ptext;
             return strlen(iconblk->ib_ptext);
            }
 if (txt) *txt = 0;
 return 0;
}
/*---------------------------- DumpEventStack --------------------------*/
/* ACTION: liste sur le disque les derniers evenements enregistres dans */
/*         la pile evenementielle d'EZ_GEM.                             */
/*         Cette fonction est ecrite  des fins de debuggage.           */
/* ENTREE: char *path: chemin du fichier  ecrire                       */
/*         char *nom: nom du fichier (peut etre egal  zero, auquel cas */
/*                    path, doit etre coplet avec nom de fichier        */
/* RETOUR: INT16: 0/si erreur       1/si tout est OK                      */

INT16 DumpEventStack(char *path_in, char *nom)
{char buft[256];
 char path[256];
 FILE *f_dest;
 INT16 last;
 long u;
 INT16 i,n; 
 strcpy(path, path_in);
 if (MS_NB==0 ||MoStack==0)                        return 0;
 if (nom) strcat(path, nom);
 if (Fic_exist(path,"")!= -1L && Fdelete(path)!=0) return 0;
 u = Fcreate(path,0);
 if (!u)                                           return 0;
 Fclose((INT16)u);
 /*................... Sortir si ouverture impossible .............*/
 if ((f_dest = fopen(path,"ab+"))==0)              return 0;
 last = Mo_ID - 1;           /* -1 car pointe toujours apres le der element place */
 if (last<0) last = MS_NB-1;
 n = 0;
 for (i = last+1; i<MS_NB; i++)
     {buft[0] = 0;
                              StrNcat(buft, itoa(MS_NB-1-n,"                  ",10),4);
      strcat(buft," Evnt: "); StrNcat(buft, itoa(MoStack[i].evnt,"                  ",10),5);
      GetEvntNames(buft+16, MoStack[i].evnt);
      strcat(buft," X: ");    StrNcat(buft, itoa(MoStack[i].x,"                  ",10),5);
      strcat(buft," Y: ");    StrNcat(buft, itoa(MoStack[i].y,"                  ",10),5);
      strcat(buft," K: ");    StrNcat(buft, itoa(MoStack[i].k,"                  ",10),3);
      strcat(buft," Ksp:  "); StrNcat(buft, itoa(MoStack[i].ksp,"                  ",10),3);
      strcat(buft," Tps:");   StrNcat(buft, ltoa(MoStack[i].time - MoStack[i-1].time,"                  ",10),10);
      strcat(buft, "\r\n");
      fwrite (buft, strlen(buft), 1, f_dest);
      n++;
     }
 for (i = 0; i<=last; i++)
     {buft[0] = 0;
      StrNcat(buft, itoa(MS_NB-1-n,"                  ",10),4);
      strcat(buft," Evnt: "); StrNcat(buft, itoa(MoStack[i].evnt,"                  ",10),5);
      GetEvntNames(buft+16, MoStack[i].evnt);
      strcat(buft," X: ");    StrNcat(buft, itoa(MoStack[i].x,"                  ",10),5);
      strcat(buft," Y: ");    StrNcat(buft, itoa(MoStack[i].y,"                  ",10),5);
      strcat(buft," K: ");    StrNcat(buft, itoa(MoStack[i].k,"                  ",10),3);
      strcat(buft," Ksp:  "); StrNcat(buft, itoa(MoStack[i].ksp,"                  ",10),3);
      strcat(buft," Tps:");   StrNcat(buft, ltoa(MoStack[i].time - MoStack[i-1].time,"                  ",10),10);
      strcat(buft, "\r\n");
      fwrite (buft, strlen(buft), 1, f_dest);
      n++;
     }
 fclose (f_dest);
 return 1;
}
/*----------------------------- GetEvntNames -----------------------------------*/
void GetEvntNames(char *buft, INT16 evnt)
{  if(evnt&MU_KEYBD) 
     {strcat (buft, " KBD");
      evnt &= ~MU_KEYBD;
     }
   if(evnt&MU_BUTTON) 
     {strcat (buft, " BUT");
      evnt &= ~MU_BUTTON;
     }
   if(evnt&MU_MOVE) 
     {strcat (buft, " MOV");
      evnt &= ~MU_MOVE;
     }
   if(evnt&MU_TIMER) 
     {strcat (buft, " TIM");
      evnt &= ~MU_TIMER;
     }
    if(evnt&MU_MESAG) 
     {strcat (buft, " MES");
      evnt &= ~MU_MESAG;
     }
   if(evnt&MU_M1) 
     {strcat (buft, " M1");
      evnt &= ~MU_M1;
     }
   if(evnt&MU_M2) 
     {strcat (buft, " M2");
      evnt &= ~MU_M2;
     }
   if(evnt&MU_UPL) 
     {strcat (buft, " UPL");
      evnt &= ~MU_UPL;
     }
   if(evnt&MU_DWL) 
     {strcat (buft, " DWL");
      evnt &= ~MU_DWL;
     }
   if(evnt&MU_UPR) 
     {strcat (buft, " UPR");
      evnt &= ~MU_UPR;
     }
   if(evnt&MU_DWR) 
     {strcat (buft, " DWR");
      evnt &= ~MU_DWR;
     }
   if(evnt) 
     {strcat (buft, " ???");
     }
   strcat(buft,  "                        " + strlen(buft));
}
/*--------------------------- StrNcat ----------------------------------*/
/* ACTION: ajoute size_t n caracteres de src a la fin de dst et si trop */
/*         long coupe  size_t n car, si trop court rajoute des espaces */
/* ENTREE: char *dst: pointe sur la chaine ou doit se faire l'ajout.    */
/*         char *src: pointe sur la chaine  rajouter.                  */
/*         size_t n: longueur du rajout.                                */
/* SORTIE: char *pointe sur dst.                                        */

char *StrNcat(char *dst, char *src, size_t n)
{size_t len_src;
 size_t len_dst;
 if (dst==0 || src==0)  return 0;
 if (*src==0)           return dst;
 len_src = strlen(src);
 len_dst = strlen(dst);
 if (len_src>n)
    {memcpy(dst + len_dst, src, n);  
    }
 else
    {strcat(dst,src);
     memset(dst + len_dst + len_src, 32, n - len_src);
    } 
 dst[len_dst+n]=0;
 return dst;
}
/*------------------------- DoPopMenuFromFile --------------------------------*/
/* ACTION: cette fonction permet de creer en memoire un menu GEM  partir     */
/*         de deux descripteurs de menu. L'un fourni par un fichier,          */
/*                                       L'autre par une chaine de caracteres */
/*         Il faut au minimum que l'un de ces deux descripteurs soit valide.  */
/*         Ce Popup est cree, initialise, affiche, et la main n'est rendue    */
/*         qu'apres selection ou non (click en dehors) d'un item du menu.     */
/*         Il est alors detruit et la memoire liberee.                        */
/*                                                                            */
/* ENTREE: OBJECT *object: adresse d'un arbre d'objet dont l'objet avec l'in- */
/*                         dice ob_ind, sert uniquement pour specifier        */
/*                         l'aspect graphique.  Si l'on ne veut pas specifier */
/*                         d'aspect graphique particulier, placez zero.       */
/*         INT16 ob_ind: indice de l'objet appartenant  l'arbre: object, qui   */
/*                     va servir de reference graphique pour l'affichage du   */
/*                     menu popup. Si OBJECT *object est egal  zero, il ne   */
/*                     sera pas tenu compte de ce paramtre, et un aspect     */
/*                     graphique par defaut sera mis en place.                */
/*         char *path_in: chemin (sans le fichier type: E:\CHEMIN\) o se     */
/*                        trouve le fichier decrivant le menu.                */
/*         char *name:        chaine pointant sur le nom du FICHIER decrivant */
/*                            le Popup. Ce fichier doit se trouver dans le    */
/*                            dossier systme du programme (celui ou se       */
/*                            trouvent les ressources). Ce fichier est un     */
/*                            texte dont chaque ligne (termine par \n\r)     */
/*                            represente une entree, ou ligne de menu.  Il ne */
/*                            peut y avoir plus simple !!!.                   */
/*         char *dest_string: sert  deux moments dans la fonction:           */
/*                                                                            */
/*                            AVANT CREATION DU MENU:                         */
/*                            ......................                          */
/*                            Pointe sur une chaine de caractres du meme     */
/*                            format que le fichier. les lignes de menu de    */
/*                            cette chaine sont rajoutes apres celles du     */
/*                            fichier. Si le premier caractre de la chaine   */
/*                            un zero de fin (chaine vide), Alors elle ne     */
/*                            sera pas utilisee pour construire le menu.      */
/*                                                                            */
/*                            APRES SELECTION D'UN ITEM DU MENU:              */
/*                            .................................               */
/*                            Et seulement si le pointeur de chaine est       */
/*                            valide ,non egal a 0 et pointant sur une chaine */
/*                            il est recopie dans cette chaine la ligne de    */
/*                            menu selectionne (chaine vide si pas de selec- */
/*                            tion). Cela permet par exemple de recuperer le  */
/*                            texte de la ligne de menu selectionnee afin     */
/*                            de l'analyser pour par exemple interpreter un   */
/*                            raccourci clavier.                              */
/*                            Prevoyer une chaine d'au moins la taille d'une  */
/*                            ligne de menu pour que la recopie ne deborde pas*/
/*                            Si vous n'avez que faire de cette recopie, et   */
/*                            que votre menu ne se compose que d'un fichier,  */
/*                            alors placez zero comme parametre.              */
/*                                                                            */
/* RETOUR: un INT16: qui est l'indice de l'objet selectionne (commence  1 pour */
/*                 premire ligne de menu). Si<=0 alors c'est soit erreur     */
/*                 soit aucune selection (click en dehors du menu).           */
/*                                                                            */
/* NOTE: l'aspect graphique indique par l'objet: object[ob_ind] est facultatif*/
/*       placez zero si vous ne disposez pas d'objet permettant de preciser   */
/*       un aspect graphique. Sinon placez par exemple, les references d'un   */
/*       objet WINDMENU tels que ceux qui servent  recevoir un menu en       */
/*       fenetre, ou de tout autre objet type G_BOXTEXT.                      */

INT16 DoPopMenuFromFile(OBJECT *object, INT16 ob_ind, char *path_in, char *name, char *dest_string)
{OBJECT* popup = DynFilePopupCreate(path_in, name, dest_string);
 INT16     ob_r  = DynFilePopupDo(object, ob_ind, popup, dest_string);
 DestroyDynamicPopup(popup);
 return ob_r;
}

/*-------------------------------- DynFilePopupCreate ------------------------*/
/* ACTION: cette fonction permet de creer en memoire un menu GEM  partir     */
/*         de deux descripteurs de menu. L'un fourni par un fichier,          */
/*                                       L'autre par une chaine de caracteres */
/*         Il faut au minimum que l'un de ces deux descripteurs soit valide.  */
/*         Ce Popup est cree, initialise en memoire, mais non affiche.        */
/*                                                                            */
/* ENTREE: char *path_in: chemin (sans le fichier type: E:\CHEMIN\) o se     */
/*                        trouve le fichier decrivant le menu.                */
/*         char *name:        chaine pointant sur le nom du FICHIER decrivant */
/*                            le Popup. Ce fichier doit se trouver dans le    */
/*                            dossier systme du programme (celui ou se       */
/*                            trouvent les ressources). Ce fichier est un     */
/*                            texte dont chaque ligne (termine par \n\r)     */
/*                            represente une entree, ou ligne de menu.  Il ne */
/*                            peut y avoir plus simple !!!.                   */
/*         char *descr_str:   Pointe sur une chaine de caractres du meme     */
/*                            format que le fichier. les lignes de menu de    */
/*                            cette chaine sont rajoutes apres celles du     */
/*                            fichier. Si le premier caractre de la chaine   */
/*                            un zero de fin (chaine vide), Alors elle ne     */
/*                            sera pas utilisee pour construire le menu.      */
/*                            Si vous placez zero dans ce parametre il n'en   */
/*                            sera pas tenu compte.                           */
/* RETOUR: OBJECT*: qui est l'adrresse de l'arbre de menu cree en memoire     */
/*                 si zero erreur lors de la creation                         */
/* NOTE: le popup ainsi cree est a detruire apres usage en faisant appel  la */
/*       fonction: DestroyDynamicPopup();                                     */

OBJECT *DynFilePopupCreate(char *path_in, char *name, char *descr_str)
{char    path[256];
 char    popup_name[64];
 long    len_str          = 0;
 long    len_fic          = 0;
 char*   str_popup        = 0;
 OBJECT* popup;
 
 /*............ copier le path d'entree .........*/
 strcpy(path, path_in);
 strcpy(popup_name, name);
 if (name || *name) PathNomToNomFic(path, 0);          /* juste epurer le path        */
 else               PathNomToNomFic(path, popup_name); /* voir si un nom suit le path */
 
 /*........ Relever longueur descripteurs .......*/
 len_fic                   = Fic_exist(path, popup_name);
 if (len_fic<10)   len_fic = 0;
 if (descr_str)    len_str = strlen(descr_str);
 /*........ si aucun descripteur valide .........*/
 if (len_str == 0 && len_fic == 0) return 0;
 /*........ si pas assez memoire cassos .........*/
 str_popup     = malloc(len_fic + len_str + 2);
 if (str_popup==0)                 return 0;
 /*........ fusionner les deux descripteurs .....*/
 if (len_fic)  Bload(path, popup_name, str_popup);
 str_popup[len_fic] = 0;
 if (len_str)  strcat(str_popup, descr_str);
 /*..... creer popup  partir de cette fusion ...*/
 popup = StringToDynPopup(str_popup, 8, 16);
 free (str_popup);  /* on n'en a plus besoin     */
 popup->ob_flags |= 0x0600;
 return popup;
}

/*--------------------------------- DynFilePopupDo -------------------------- */
/* ACTION: cette fonction affiche et gere l'action de la souris, sur un menu  */
/*         popup dont l'adresse de l'arbre en memoire est donnee  par la      */
/*         variable d'entree: OBJECT *popup , et la main n'est rendue         */
/*         qu'apres selection ou non (click en dehors) d'un item du menu.     */
/*                                                                            */
/* ENTREE: OBJECT *graf_object: adresse d'un arbre d'objet dont l'objet avec  */
/*                         indice graf_obind, sert uniquement pour specifier  */
/*                         l'aspect graphique.  Si l'on ne veut pas specifier */
/*                         d'aspect graphique particulier, placez zero.       */
/*         INT16 graf_obind: indice de l'objet de l'arbre: graf_object, qui     */
/*                     va servir de reference graphique pour l'affichage du   */
/*                     menu popup. Si OBJECT *graf_object est egal  zero, il */
/*                     ne sera pas tenu compte de ce paramtre, et un aspect  */
/*                     graphique par defaut sera mis en place.                */
/*         OBJECT *popup: adresse de l'arbre de menu  activer.               */
/*                                                                            */
/*         char *dest_string: Et seulement si le pointeur de chaine est       */
/*                            valide ,non egal a 0 et pointant sur une chaine */
/*                            il est recopie dans cette chaine la ligne de    */
/*                            menu selectionne (chaine vide si pas de selec- */
/*                            tion). Cela permet par exemple de recuperer le  */
/*                            texte de la ligne de menu selectionnee afin     */
/*                            de l'analyser pour par exemple interpreter un   */
/*                            raccourci clavier.                              */
/*                            Prevoyer une chaine d'au moins la taille d'une  */
/*                            ligne de menu pour que la recopie ne deborde pas*/
/*                            Si vous n'avez que faire de cette recopie, et   */
/*                            que votre menu ne se compose que d'un fichier,  */
/*                            alors placez zero comme parametre.              */
/*                                                                            */
/* RETOUR: un INT16: qui est l'indice de l'objet selectionne (commence  1 pour */
/*                 premire ligne de menu). Si<=0 alors c'est soit erreur     */
/*                 soit aucune selection (click en dehors du menu).           */
/*                                                                            */
/* NOTE: l'aspect graphique indique par l'objet: graf_object[graf_obind] est  */
/*       facultatif.                                                          */
/*       placez zero si vous ne disposez pas d'objet permettant de preciser   */
/*       un aspect graphique. Sinon placez par exemple, les references d'un   */
/*       objet WINDMENU tels que ceux qui servent  recevoir un menu en       */
/*       fenetre, ou de tout autre objet type G_BOXTEXT.                      */

INT16 DynFilePopupDo(OBJECT *graf_object, INT16 graf_obind, OBJECT *popup, char *dest_string)
{INT16 ob_r = -1;
 if (popup)
    {wind_update( BEG_MCTRL );
     SetMouseForm(ARROW);
     while(Mousek());
     if (graf_object==0)
         ob_r  = PopupDo(popup, 0, 2, Mousex(), Mousey(), 0);
     else
         ob_r  = PopupListDo( graf_object, graf_obind, popup,  0, Mousex(), Mousey(), 0, 0);

     /*........si chaine de retour existe y .....*/
     /*        recopier la ligne selectionnee    */
     /*        si valide sinon un zero de fin    */
     if (dest_string)
        {if (ob_r >0)  strcpy(dest_string,  popup[ob_r].ob_spec.free_string);
         else         *dest_string = 0;
        }
     wind_update( END_MCTRL ); 
    }
 else if (dest_string)     
    {*dest_string = 0; /* chaine de retour vide */
    }
 while(Mousek());
 return ob_r;
}
/*------------------------- StringToDynPopup ------------------------*/
/* ACTION: Cette fonction cree un menu GEM  partir d'une chaine de  */
/*         caractere decrivant le menu: Cette chaine est un texte    */
/*         dont chaque ligne (termine par \n\r), represente une     */
/*         entree de menu, dit aussi une ligne de menu. Il ne peut y */
/*         avoir plus simple !!!. Exemple de menu  2 lignes:        */
/*             " Copier    CTRL C \n\r  Coller    CTRL V \n\r"       */
/* ENTREE: const char *str: cahine decrivant le menu.                */
/*         short w_car: largeur d'un caractere du menu (defaut = 16) */
/*         short h_car: hauteur d'un caractere du menu (defaut = 8)  */
/* SORTIE: OBJECT *  pointe sur l'objet racine du menu GEM cree.     */
/*                   si zero alors erreur.                           */
/* NOTE: cette creation est dynamique, il convient et est laisse    */
/*       votre charge le soin de detruire ce menu, en utilisant la   */
/*       fonction: void DestroyDynamicPopup(OBJECT *pop_up);         */

OBJECT *StringToDynPopup(const char *str, short w_car, short h_car )
{long    len_max;
 OBJECT *popup;
 long    nb_lgn;
 char   *str_cpy;
 char  **PtLgnTab;
 INT16 i;
 /*.......... reserver chaine tampon de travail .....................*/
 str_cpy          = malloc(strlen(str)+1);
 if (str_cpy == 0)                  return 0;
 strcpy(str_cpy, str);
 /*.......... creer tableau de chaines ..............................*/
 nb_lgn           = GetTexteNbLigne(str_cpy, 0, 0); 
 PtLgnTab         = (char **)malloc((nb_lgn+1)*sizeof(char **));
 if (PtLgnTab==0 )  {free(str_cpy); return 0;}
 /*.......... initialiser le tableau en mettant zero de fin ...*/
 len_max          = GetTexteNbLigne(str_cpy, PtLgnTab, 1);
 /*.......... creer le popup ........................................*/
 popup            = CreateDynamicPopup((INT16)nb_lgn, len_max, w_car, h_car);
 if (popup==0)                      goto Exit_StringToDynPopup;
 /*......... initialiser les chaines des item avec celle d'entree ...*/
 for (i=0; i< (INT16) nb_lgn; i++)
     {strcpy( popup[i+1].ob_spec.free_string, PtLgnTab[i]);
      if ( PtLgnTab[i][0]=='-') popup[i+1].ob_state |= DISABLED;
     }
 Exit_StringToDynPopup:
 free (PtLgnTab);
 free (str_cpy);
 return popup;
}

/*------------------------- CreateDynamicPopup -----------------------*/
/* ACTION: Cette fonction cree un menu GEM en memoire.                */
/* ENTREE: short nb_item: nombre de lignes de menu devant etre creees */
/*         short nb_cara: largeur en nombre de caracteres de chaque   */
/*                        ligne de menu.                              */
/*         short w_car: largeur d'un caractere du menu (defaut = 16)  */
/*         short h_car: hauteur d'un caractere du menu (defaut = 8)   */
/* SORTIE: OBJECT *  pointe sur l'objet racine du menu GEM cree.      */
/*                   si zero alors erreur.                            */
/* NOTE: cette creation est dynamique, il convient et est laisse     */
/*       votre charge le soin de detruire ce menu, en utilisant la    */
/*       fonction: void DestroyDynamicPopup(OBJECT *pop_up);          */

OBJECT *CreateDynamicPopup(short nb_item, short nb_cara, short w_car, short h_car)
{INT16 i;
 OBJECT *pop_up;
 pop_up = (OBJECT *)calloc((nb_item + 1), sizeof (OBJECT));
    
 if ( pop_up )
    {/*DEFINITION DU PERE ([0])*/
     pop_up->ob_next                    = -1;
     pop_up->ob_head                    = 1;
     pop_up->ob_tail                    = nb_item;
     pop_up->ob_type                    = G_BOX;
     pop_up->ob_flags                   = NONE;
     pop_up->ob_state                   = SHADOWED;
     pop_up->ob_spec.obspec.framesize   = -2;
     pop_up->ob_spec.obspec.framecol    = 1;
     pop_up->ob_spec.obspec.textcol     = 1;
     pop_up->ob_spec.obspec.fillpattern = 0;
     pop_up->ob_x                       = 0;
     pop_up->ob_y                       = 0;
     pop_up->ob_width                   = nb_cara * w_car+8;
     pop_up->ob_height                  = nb_item * h_car+6;

    /*DEFINITION DU PREMIER FILS*/
     pop_up[1].ob_next             = 0;
     pop_up[1].ob_head             = -1;
     pop_up[1].ob_tail             = -1;
     pop_up[1].ob_type             = G_STRING;
     pop_up[1].ob_flags            = TOUCHEXIT|LASTOB;
     pop_up[1].ob_state            = NORMAL;
     pop_up[1].ob_spec.free_string = calloc(nb_cara + 4, sizeof(char));
     pop_up[1].ob_x                = 0;
     pop_up[1].ob_y                = 3;
     pop_up[1].ob_width            = nb_cara * w_car + 4;
     pop_up[1].ob_height           = h_car;
     
    /*DEFINITION DES AUTRES FILS*/    
     if (nb_item > 1)
        {INT16 posx   = 0;
         INT16 posy   = 3;
         for (i = 2; i <= nb_item; i++)
             {pop_up[i-1].ob_next           = i;
              pop_up[i].ob_next             = 0;
              pop_up[i].ob_head             = -1;
              pop_up[i].ob_tail             = -1;
              pop_up[i].ob_type             = G_STRING;
              pop_up[i-1].ob_flags          = TOUCHEXIT|NONE;
              pop_up[i].ob_flags            = TOUCHEXIT|LASTOB;
              pop_up[i].ob_state            = NORMAL;
              pop_up[i].ob_spec.free_string = calloc(nb_cara + 4, sizeof(char));
              pop_up[i].ob_x                = posx;
              posy                         += h_car;
              pop_up[i].ob_y                = posy;
              /* pop_up[i].ob_y                = (i -1)  * h_car + 3; */
              pop_up[i].ob_width            = nb_cara * w_car + 4;
              pop_up[i].ob_height           = h_car;
              if (posy>= Ecran_h - h_car*5)
                 {posy  = 3;
                  posx +=  pop_up[i].ob_width + 3;
                 }
            }/*for*/
        }/*if*/
    }/*if*/    
 return pop_up;
}/*creer_pop_up*/

/*-------------------- DestroyDynamicPopup --------------------------*/
/* ACTION: libere la memoire reservee par un popup dynamique.        */
/* ENTREE: OBJECT *pop_up: pointe sur le popup  detruire.           */
/* RETOUR: neant.                                                    */
void DestroyDynamicPopup(OBJECT *pop_up)
{INT16 i;
 INT16 nb_item = 0;
 if(pop_up == NULL) return;
 /*........  compter les objets ......................................*/
 while ( !(pop_up[nb_item].ob_flags & LASTOB)) nb_item++;
 for (i=1; i<=nb_item; i++)
     {if(pop_up[i].ob_spec.free_string!=NULL) free(pop_up[i].ob_spec.free_string);
     }
 free(pop_up);
}/*DestroyDynamicPopup*/

/*------------------- GetTexteNbLigne -------------------------------*/
/* ACTION: Fonction tres versatile, selon si is_C_end = 0 ou         */
/*                                           is_C_end = 1            */
/*      SI is_C_end  = 0 Elle passe en revue le texte et compte le   */
/*                     nombre de lignes (-1  base 0)                 */
/*                     il est retourne alors le nombre de lignes -1  */
/*      SI is_C_end  = 1 Elle passe en revue le texte et met un zero */
/*                     de fin  la fin de chaque ligne               */
/*                     il est retourne alors la longueur maxi renc-  */
/*                     contre d'une ligne.                          */
/*      Si PtLgnTab !=0 donc pointe sur un tableau de pointeurs de   */
/*                      chaine, il est rempli avec les des lignes    */
/* NOTE: est considre comme ligne toute chaine de caractre        */
/*       termine par: \n ou \r ou \r\n ou \n\r. (cela vous va ?)    */
/*                                                                   */
/* ENTREE: char *txt: pointe sur le texte  traiter.                 */
/*         char **PtLgnTab: pointe sur un tableau de pointeurs de    */
/*                          chaines, initialise sur chaque debut de  */
/*                          lignes (si il est  valide CAD  != 0)     */
/*         char is_C_end: voir plus haut.                            */
/* RETOUR: un long: dont la signification de la valeur depend de la  */
/*                  valeur de is_C_end: (voir plus haut)             */

long GetTexteNbLigne(char *txt, char **PtLgnTab, char is_C_end)
{char *pt, *last_pt;
 long nb_lgn  = 0;
 long len_max = LONG_MIN;
 pt           = txt;
 last_pt      = pt;
 if (PtLgnTab) PtLgnTab[nb_lgn] = pt; /* initialiser le premier pointeur */
 while(*pt)
   {if (*pt==13 || *pt==10) 
       {len_max = Max(len_max, (long)(pt-last_pt));
        pt++; 
        if (*pt && pt[-1]==13 && *pt==10)
           { if (is_C_end) pt[-1] = 0;
             pt++;
           }
        else if (is_C_end) pt[-1] = 0;
        nb_lgn++;
        if (PtLgnTab) PtLgnTab[nb_lgn] = pt; /* initialiser les autres pointeurs */
        last_pt = pt;
       } 
     else
       {pt++;
       }
   }
 len_max = Max(len_max, (long)(pt-last_pt));
 if (is_C_end) return len_max;
 else          return  nb_lgn;
}

/*-------------------------- WindCycle ---------------------------------*/
/* ACTION: change la fenetre de premier plan de notre application,      */
/*         en mettant en avant plan la prochaine fenetre de notre       */
/*         l'application. Si c'est la derniere fenetre, alors c'est la  */
/*         premiere qui est mise en avant plan (a cycle).              */
/* ENTREE: INT16 *old_wind: si ce pointeur est different de 0 (valide)    */
/*         il est retourne dans la variable pointee par ce pointeur, la */
/*         fenetre en avant plan avant appel a la fonction.             */
/* RETOUR: INT16  qui est -1 si erreur.                                   */
/*                      L'indice EASY_GEM de la fenetre mise 1er plan   */

INT16 WindCycle(INT16 *old_wind)
{INT16 wh_top,d;                    /* handle fenetre en avant plan         */
 INT16 wind;                      /* fenetre active                       */
 INT16 next_wind;
 wind_get( 0, WF_TOP, &wh_top, &d,&d,&d); /* recuperer handle fen. avt plan.      */
 wind = WindHandToIndice(wh_top);
 /*............ si la fenetre au top appartient  notre application ....*/
 
 if (wind< MAX_WIND)
    {next_wind = wind;
     do {next_wind++;
         if (next_wind              >= MAX_WIND ||  /* apres der fenetre possible */
             Windtab[next_wind].w_h == -1           /* apres der fenetre creee    */
            )
            {next_wind = 0;
            }
        }/*..... ne sort que si on reboucle  la fenetre de depart........*/
         /*      ou si la nouvelle fenetre est ouverte (donc valide)      */
         while (!(Windtab[next_wind].w_flag & W_IS_OPEN) && 
                  next_wind != wind
               );
   }
 else  
   {if (old_wind) *old_wind = -1;
    return -1; /* pas une fenetre de notre application */
   }
 /*..... si appartient  notre appli et changement de fenetre ........*/
 if (next_wind !=-1 && wind != next_wind)
    {SendWindMessage(GETGEMHAND(next_wind), WM_TOPPED, &Windtab[next_wind].GemWorkGrect);
    }
      
 if (old_wind) *old_wind = wind;
 return next_wind;
}

/*-------------------------- SetSlideMinimum -------------------------------*/
/* ACTION: defini la largeur minimum possible des ascenseurs des SCROLL_BAR */
/*         par defaut cette valeur est de 5. Cette fonction ne concerne     */
/*         evidemment que les SCROLL_BOX, SCROLL_EDIT, SCROLL_TEXTE ayant   */
/*         un dispositif de SCROLL_BAR automatique. Tous les appels explic- */
/*         ites, aux fonctions de reglage des ascenseurs comportent en      */
/*         paramtre, cette longuer minimum, a vous de la placer lors de    */
/*         l'appel !. Une variable globale dans EASY_GEM stocke cette       */
/*         valeur: MIN_SLIDE_W: vous pouvez la modifier directement.        */
/*         Cette valeur concerne SCROLL_BOX, SCROLL_EDIT, SCROLL_TEXTE du   */
/*         programme.                                                       */
/* ENTREE: INT16 width: valeur minimum souhaite pour les ascenseurs. Cette   */
/*                    valeur sera limite a 3 en minimum et 50 en maximum.   */
/* SORTIE: INT16:   valeur effectivement mise en place.                       */

INT16 SetSlideMinimum(INT16 width)
{ MIN_SLIDE_W = Min(50,Max(3, width));
  return MIN_SLIDE_W;
}
/*---------------------------- ClearKeybdMessage ---------------------------*/
/* ACTION: permet de vider le tampon GEM clavier sans executer les touches  */
/*         clavier mais d'executer tous les autres messages empils         */
/*         cela permet d'eviter la repetition d'une touche clavier lorsque  */
/*         son traitement a pris du temps et que le tampon GEM s'est rempli */
/*         d'evenements claviers. Appeler donc cette fonction apres celle   */
/*         traitant le clavier, afin de vider le buffer GEM.                */                                
/* ENTREE: CALLBACK (*Men_proc)(INT16 wind, EVNT_O *Evnt):  pointeur sur la   */
/*                 fonction de traitement  par defaut des messages (si elle */
/*                 existe) peut tres bien etre zero, et alors la fonction   */
/*                 par defaut ne sera pas appele.                          */
/* SORTIE: INT16 nbr de messages executes.                                    */
                      
INT16 ClearKeybdMessage( CALLBACK (*Men_proc)(INT16 wind, EVNT_O *Evnt) )
{INT16 msgbuf[16];
 INT16 old_message=0;
 INT16 poursuivre=1;
 INT16 i=0;
 
 EVNT_O evnt_o;           /*   structure de reception evenements sortie      */ 
 /*........ envoyer un message pour etre sur d'en recevoir un et de pas......*/
 /*                       boucler ternellemnt                               */
 msgbuf[MESG]=END_KEYBD;  /*   message de queue                              */
 msgbuf[APPL]=Appl_id;    /*   iddentificateur de l'appelant (moi)           */
 msgbuf[SUPL]=0;          /*   message sans surplus                          */
 appl_write(Appl_id, 16, msgbuf );                 
 
 while (poursuivre) 
  {evnt_mesag( &evnt_o.pipe[0]);
   evnt_o.evnt = MU_MESAG;  
   if (old_message == END_KEYBD && evnt_o.pipe[MESG]==END_KEYBD)
      {poursuivre=0;
      }
   else
      {old_message = evnt_o.pipe[MESG]; 
       if (old_message != END_KEYBD) {evnt_o.evnt &= ~MU_KEYBD;
                                      Event_dispatch( &evnt_o, Men_proc); 
                                      i++;
                                     } 
       msgbuf[MESG]=END_KEYBD;    /*   message de queue                              */
       msgbuf[APPL]=Appl_id;      /*   iddentificateur de l'appelant (moi)           */
       msgbuf[SUPL]=0;            /*   message sans surplus                          */
       appl_write(Appl_id, 16, msgbuf ); 
     }
  } /* end while */ 
 return i; 
}

/*--------------------------- WindMoveRedraw --------------------------------*/
/* ACTION:      sert a optimiser les redraws lors de deplacements dans une   */
/*              fenetre. Deplace les zones qui peuvent l'etre et demande un  */
/*              redraw pour les autres.                                      */
/*                  initialement ecrite par Gerome GINESTET pour SI_WORK,   */
/*                  modifiee par SEVIN Roland pour EAZY_GEM.                */
/* ENTREE:  INT16 w_ind : handle EazyGem de la fenetre concerne               */
/*          INT16 xo, yo : deplacements horizontaux et verticaux. Peuvent etre */
/*                       positifs ou negatifs                                */
/*          GRECT *scrol_grect : rectangle  faire scroller dans la fenetre. */
/*          void  *redraw_f() : pointeur sur la fonction effectuant les      */
/*                             redraws pour la fenetre concernee  cette      */
/*                             fonction doit pouvoir gerer trois parametres: */
/*                         INT16 w_ind :  handle EazyGem fenetre concerne.    */
/*                         GRECT *scrol_grect : rectangle dans lequel le     */
/*                                              scrolling se fait. Ce rectan-*/
/*                                              gle vous est donn pour info.*/
/*                                              et est le meme que celui     */
/*                                              fourni en entree.            */
/*                         GRECT *update_grect : rectangle  redessiner,     */
/*                                              (deja clip)                 */
/*                         void  *user_param: un parametre quelconque laisse */
/*                                            libre  l'utilisateur pour ses */
/*                                            propres besoins. (peut passer  */
/*                                            un pointeur sur un contexte ou */
/*                                            tout autre information dont il */
/*                                            aura besoin dans la fonction)  */
/*                                            ce parametre est le meme que   */
/*                                            celui transmis  la fonction   */
/*                                            WindMoveRedraw().              */
/*                                                                           */
/*          void  *user_param: un parametre quelconque laisse libre         */
/*                             l'utilisateur pour ses propres besoins.       */
/*                             (peut passer  un pointeur sur un contexte ou  */
/*                              tout autre information dont il aura besoin   */
/*                              dans la fonction)                            */
/*                             Ce parametre sera aussi transmis  la         */
/*                             fonction redraw_f() lors de son appel, dans   */
/*                             son parametre:  user_param.                   */
/*                                                                           */
/* NOTE: Si vous appelez WindMoveRedraw() avec redraw_f  zero, la fonction  */
/*       associee a la fenetre w_ind, sera directement appele avec le       */
/*       message WM_PAINT, afin de mettre a jour le rectangle a redesiner    */
/* REMARQUE : la fonction redraw_f ne doit pas gerer la rectangle list de la */
/*            fenetre sous peine de plantage car wind_move_redraw la gere    */
/*            Cette fonction passant par la liste des rectangle permet le    */
/*            scrolling en arrire plan.                                     */

void WindMoveRedraw( INT16 w_ind, 
                     INT16 xo, INT16 yo,
                     GRECT *scrol_grect,
                     void (*redraw_f)( INT16 w_ind, 
                                       GRECT *scrol_grect, 
                                       GRECT *update_grect,
                                       void  *user_param
                                     ),
                     void  *user_param
                   )
{
 INT16 xs,ys,xd,yd;
 GRECT xyr,xyc /*,gem_work */, xyl;  /*xydk gem_work */ /* xyw scrol_grect */
 INT16 w_h=GETGEMHAND(w_ind);
 if (redraw_f == 0) redraw_f = DirectRedrawMessage;
 /* wind_get( 0, WF_WORKXYWH, &gem_work.g_x, &gem_work.g_y, &gem_work.g_w, &gem_work.g_h ); */
 Mouse_off();
 wind_update( BEG_UPDATE );
 wind_get(w_h,WF_FIRSTXYWH,&xyl.g_x,&xyl.g_y,&xyl.g_w,&xyl.g_h);
 while(xyl.g_w && xyl.g_h)
  {xyc = xyl;
   if(Rc_intersect(scrol_grect, &xyc))
     {/*if(Rc_intersect(&gem_work,&xyc)) */
        {if( abs(xo)>=xyc.g_w || abs(yo)>=xyc.g_h )
            redraw_f(w_ind, scrol_grect, &xyc, user_param);
         else
           {if(yo<0)
              {ys=xyc.g_y-yo;
               yd=xyc.g_y;
              }
            else
              {ys=xyc.g_y;
               yd=xyc.g_y+yo;
              }
            
            if(xo<0)
              {xs=xyc.g_x-xo;
               xd=xyc.g_x;
              }
            else
              {xs=xyc.g_x;
               xd=xyc.g_x+xo;
              }
            Rc_copy(xs,ys,xyc.g_w-abs(xo),xyc.g_h-abs(yo),xd,yd);
            
            if(yo)
              {xyr.g_x=xyc.g_x;
               xyr.g_w=xyc.g_w;
               xyr.g_h=abs(yo);
               if(yo<0)
                  xyr.g_y=xyc.g_y+xyc.g_h+yo;
               else
                  xyr.g_y=xyc.g_y;
               redraw_f(w_ind, scrol_grect, &xyr, user_param);
               if(xo)
                 {xyr.g_w=abs(xo);
                  xyr.g_h=xyc.g_h-abs(yo);
                  if(xo<0)
                     xyr.g_x=xyc.g_x+xyc.g_w+xo;
                  else
                     xyr.g_x=xyc.g_x;
                  if(yo>0)
                     xyr.g_y=xyc.g_y+yo;
                  else
                     xyr.g_y=xyc.g_y;
                  redraw_f(w_ind, scrol_grect, &xyr, user_param);
                 }/* endif (xo) */
              } /* endif (yo) */
            else if(xo)
              {xyr.g_y=xyc.g_y;
               xyr.g_w=abs(xo);
               xyr.g_h=xyc.g_h;
               if(xo<0)
                  xyr.g_x=xyc.g_x+xyc.g_w+xo;
               else
                  xyr.g_x=xyc.g_x;
               redraw_f(w_ind, scrol_grect, &xyr, user_param);
              }
           } /* end else de if( abs(xo)>=xyc.g_w || abs(yo)>=xyc.g_h ) */
        } /* endif(Rc_intersect(&gem_work,&xyc)) */
     } /* endif(Rc_intersect(&scrol_grect,&xyc)) */
   wind_get(w_h,WF_NEXTXYWH,&xyl.g_x,&xyl.g_y,&xyl.g_w,&xyl.g_h);
  } /* endwhile(xyl.g_w && xyl.g_h) */
 wind_update( END_UPDATE );
 Mouse_on();
}

/*----------------------- DirectRedrawMessage ------------------------------*/
void DirectRedrawMessage(INT16 w_ind, GRECT * scrol_grect, GRECT *update_grect, void *param)
{EVNT_O Evnt_mess;
 Evnt_mess.evnt                = MU_MESAG;
 Evnt_mess.x                   = 0; /* Mousex(); */
 Evnt_mess.y                   = 0; /* Mousey(); */
 Evnt_mess.k                   = 0; /* Mousek(); */
 Evnt_mess.ksp                 = 0; /* (INT16)Kbshift(-1); */
 Evnt_mess.key                 = 0;
 Evnt_mess.click               = 0;
 Evnt_mess.pipe[MESG]          = WM_PAINT;  
 Evnt_mess.pipe[APPL]          = Appl_id;                  /*   iddentificateur de l'appelant (moi)  */
 Evnt_mess.pipe[SUPL]          = 0;                        /*   message sans surplus                 */
 Evnt_mess.pipe[WHND]          = GETGEMHAND(w_ind);
 *(GRECT*)&Evnt_mess.pipe[X_G] = *update_grect;
 *(GRECT*)&Evnt_mess.pipe[X_B] = *scrol_grect;
 *(long*) &Evnt_mess.pipe[S_0] = (long)param;
  ClipGrect(update_grect);
 Windtab[w_ind].w_proc(w_ind, &Evnt_mess);
}

/*----------------------------------- Rc_copy -------------------------------*/
/* ACTION: rc_copy : pour simplifier le deplacement ou la copie de           */ 
/*                  blocs graphiques a l'ecran                               */
/* ENTREE: xs, ys, ws, hs : coordonnes de la zone source                    */
/*         xd, yd : coordonnes de la zone destination                       */

void Rc_copy( INT16 xs, INT16 ys, INT16 ws, INT16 hs, INT16 xd, INT16 yd)
{
 INT16 xy[8];
 
 xy[0]=xs;
 xy[1]=ys;
 xy[2]=xs+ws-1;
 xy[3]=ys+hs-1;
 xy[4]=xd;
 xy[5]=yd;
 xy[6]=xd+ws-1;
 xy[7]=yd+hs-1;
 vs_clip( VDIhandle, 0, xy );
 vro_cpyfm(VDIhandle,3,xy,&Screen_MFDB,&Screen_MFDB);
  
}

/*--------------------- GetKeyboardFocus -------------------------------*/
/* ACTION: retourne l'objet possedant le focus clavier.                 */
/* ENTREE: INT16 w_ind:  indice EAZY_GEM de la fenetre ou se trouve       */
/*                     l'arbre de ressource dont on cherche a connaitre */
/*                     l'objet qui possede le focus clavier.            */
/* RETOUR: indice de l'objet ayant le focus.                            */

INT16 GetKeyboardFocus(INT16 w_ind)
{ DLG_VAR *dlg     = &Windtab[w_ind].DlgVar;  
 if (dlg->LstAdr) return (INT16) dlg->LstAdr;
 else             return dlg->ObjEdit;
}


/*--------------------- GetObjectInterior ------------------------------*/
/* ACTION: retourne le type VDI de motif avec lequel un objet est trace */
/* ENTREE: OBJECT *object: pointe sur le premier objet de l'arbre       */
/*                         d'objets dans lequel se trouve notre objet.  */
/*         INT16 ind: indice de notre objet dans l'arbre d'objets.        */
/*         INT16 *type: pointe sur la variable dans laquelle sera retour- */
/*                    nee le type VDI de motif. A utiliser avec la      */
/*                    fonction: vsf_interior();                         */
/*         INT16 *motif:pointe sur la variable dans laquelle sera retour- */
/*                    nee le motif VDI. A utiliser avec la              */
/*                    fonction: vsf_style();                            */
/*         INT16 *color:pointe sur la variable dans laquelle sera retour- */
/*                    nee la couleur VDI. A utiliser avec la            */
/*                    fonction: vsf_color();                            */
/* RETOUR: INT16 indice EAZY_GEM de la trame. A utiliser avec les         */
/*                   fonctions:        TrameToNumSel();                 */                 
/*                                     NumSelToTrame();                 */
/* NOTE: on peut passer zero pour les parametres: type, motif, color    */
/*       la fonction ne retournera bien sur, rien sur ceux mis a zero   */
 
INT16 GetObjectInterior(OBJECT *object, INT16 ind, INT16 *type, INT16 *motif, INT16 *color)
{TEDINFO  *tedinfo;
 XUSERBLK *xuserblk;
 INT16 backMotif;
 INT16 o_type = object[ind].ob_type;
 INT16 x_type = GET_XOBTYPE(object,ind);
 /*....................... rechercher le TEDINFO .....................*/
 if  ( ((o_type & G_FBOXTEXT || o_type & G_FTEXT) && object[ind].ob_flags & EDITABLE) ||
       (x_type >= GROUP_LITLE   &&  x_type <= SCROLL_EDIT)
     )
     {xuserblk   = (XUSERBLK*) object[ind].ob_spec.userblk->ub_parm; 
      tedinfo    = xuserblk->tedinfo;
      if (color) *color     = (tedinfo->te_color) & 0x000F;
      backMotif  = (tedinfo->te_color>>4)  & 0x0007;
     }
  else if (o_type == G_TEXT ||o_type == G_FTEXT ||o_type == G_BOXTEXT || o_type == G_FBOXTEXT)
     {tedinfo    = object[ind].ob_spec.tedinfo;
      if (color) *color     = (tedinfo->te_color) & 0x000F;
      backMotif  = (tedinfo->te_color>>4)  & 0x0007;
     }
  else if (o_type == G_BOX ||o_type == G_IBOX ||o_type == G_BOXCHAR)
     {if (color) *color    = object[ind].ob_spec.obspec.interiorcol;
      backMotif = object[ind].ob_spec.obspec.fillpattern;
     }
  else return 0;
  
 if (backMotif)
        {backMotif++;
         if (backMotif==8) 
            {backMotif = 8;
             if (type)  *type  = FIS_SOLID;
             if (motif) *motif = backMotif;
             return TrameToNumSel(FIS_SOLID, backMotif);
            }
          else
            {if (type)  *type  = FIS_PATTERN;
             if (motif) *motif = backMotif;
             return TrameToNumSel(FIS_PATTERN, backMotif);
            }
        }
 else
        {if (type)  *type  = FIS_SOLID;
         if (motif) *motif = backMotif;
         return TrameToNumSel(FIS_SOLID, 0);
        }    
}

/*-------------------------- ExeWindMessage ----------------------------*/
/* ACTION: permet d'envoyer  une fenetre un message quelconque.        */
/*         SI le parametre n_param: est positif: l'execution du message */
/*                         est immediate cette fonction  ne passe pas   */
/*                         par la messagerie GEM, mais execute          */
/*                         directement la fonction de fenetre associee  */
/*                          w_ind. C'est utile lorsque l'on desire     */
/*                         effectuer quelque chose (par exemple une     */
/*                         mise a jour avant un redraw) avant la        */
/*                         messagerie GEM.                              */
/*         SI le parametre n_param: est negatif: sa valeur absolue      */
/*                         indique le nombre de paramtres, et la pile  */
/*                         des messages GEM sera utilise normalement.  */
/* ENTREE: INT16 w_ind: handle EAZY_GEM de la fenetre cible.              */
/*         INT16 messg: message  envoyer                                 */
/*         INT16 *param: parametres sous forme d'un tableau d'INT16         */
/*                SI *param est egal  zero le tableau de parametres    */
/*                    est ignor                                        */
/*                SINON le premier parametre sera copie en:             */
/*                         Evnt.pipe[X_G] et les autres suivent apres.  */
/*                         pour memoire: X_G = 4                        */
/*         INT16 n_param: nombre de parametres  copier, la facon dont le */
/*                      message est envoy  la procedure de fenetre    */
/*                      depend du caractere positif ou negatif de ce    */
/*                      parametre (voir un peu plus haut)               */
/*                                                                      */

INT16 ExeWindMessage(INT16 w_ind, INT16 messg, INT16 *param, INT16 n_param)
{EVNT_O Evnt_mess;
 INT16 n_par = abs(n_param);
 Evnt_mess.evnt       = MU_MESAG;
 Evnt_mess.x          = 0; /*Mousex();*/
 Evnt_mess.y          = 0; /*Mousey();*/
 Evnt_mess.k          = 0; /*Mousek();*/
 Evnt_mess.ksp        = 0; /*(INT16)Kbshift(-1);*/
 Evnt_mess.key        = 0;
 Evnt_mess.click      = 0;
 Evnt_mess.pipe[MESG] = messg;  
 Evnt_mess.pipe[APPL] = Appl_id;                   /*   iddentificateur de l'appelant (moi)  */
 Evnt_mess.pipe[SUPL] = 0;                        /*   message sans surplus                 */
 Evnt_mess.pipe[WHND] = Windtab[w_ind].w_h;        /*   fenetre  qui est dediee le message  */
 if (param) memcpy(&Evnt_mess.pipe[X_G ], param, Min(16, n_par) * sizeof(INT16) );
 if      (n_param>=0)     return (Windtab[w_ind].w_proc)(w_ind , &Evnt_mess);
 else if (n_param<0)      return appl_write(Appl_id, 16, &Evnt_mess.pipe[MESG]);
 return 0;
}

/*------------------------- ToolTipAddGrect ----------------------------*/
/* ACTION: rajoute un rectangle declenchant  la liste des rectangles   */
/*         declenchant de bulle d'aide. Lorsque la souris restera un    */
/*         certain temps au dessus de ce rectangle, un message de       */
/*         bulles d'aides: WM_TT_GET_TXT sera gnr, avec:             */
/*         Evnt->pipe[X_G]==TT_GRECT (cela permet de le distinguer      */
/*                                    des autres messages de bulles     */
/*                                    d'aides.)                         */
/*         Evnt->pipe[Y_G] = ident (cela permet de savoir quel rectan-  */
/*                                 gle est responsable du message)      */
/*         *(long*)&Evnt.pipe[X_B] = adresse du rectangle declenchant   */
/*                                   en coordonnees absolues ecran.     */
/*         *(long*)&Evnt.pipe[W_G] adresse de l'endroit  ou le texte    */
/*                                 de la bulle doit etre place          */
/* ENTREE: INT16 w_ind: indice EZ_GEM de la fenetre pour laquelle un      */
/*                    rectangle de bulle d'aide doit etre installe.     */
/*         INT16 ident: Identificateur libre qui permet de distinguer     */
/*                    les diffrents rectangles dclenchants entre eux. */
/*                    C'est  l'application (donc au programmeur soit   */
/*                     vous) de grer l'unicit de cet identificateur  */
/*                    Pour une meme fenetre il ne peut y avoir deux     */
/*                    rectangles ayant le meme identificateur, auquel   */
/*                    cas ces deux rectangles diffrents entraineront   */
/*                    le dclenchement du meme message: WM_TT_GET_TXT.  */
/*                    Remarquons que cela peut etre utilis  dessein.  */
/*         GRECT *grect: pointe sur l'adresse du rectangle declenchant  */
/*                       il n'y a recopie de ce rectangle par EZ_GEM.   */
/*                       il vous faut donc spcifier une adresse        */
/*                       statique ou globale.                           */
/*                       IMPORTANT: les coordones de ce rectangle      */
/*                                  doivent etre en relatif par rapport */
/*                                  aux dimensions externes de la       */
/*                                  fenetre.                            */
/* RETOUR: -1 si erreur (plus de place dans la liste des rectangles).   */
/*                                                                      */
/* IMPORTANT: il faut liberer ce rectangle par la fonction:             */
/*                           ToolTipDelGrect()                          */
/*                                            lorsqu'on en a plus       */
/*            besoin, car sinon risque de saturation de la liste. Par   */
/*            exemple lors du traitement du message WM_DESTRUCT.        */

INT16 ToolTipAddGrect(INT16 w_ind, INT16 ident, GRECT *grect)
{ToolTipDel(Windtab[w_ind].w_h, TT_GRECT, ident, grect); 
 return ToolTipAdd(Windtab[w_ind].w_h, TT_GRECT, ident, grect);
}

/*------------------------- ToolTipDelGrect ----------------------------*/
/* ACTION: supprime un rectangle declenchant de la liste des rectangles */
/*         declenchant de bulles d'aides.                               */ 
/* ENTREE: INT16 w_ind: indice EZ_GEM de la fenetre pour laquelle un      */
/*                    rectangle de bulle d'aide doit etre supprime.     */
/*         INT16 ident: Identificateur libre qui permet de distinguer     */
/*                    les diffrents rectangles dclenchants entre eux. */
/*                    C'est  l'application (donc au programmeur soit   */
/*                     vous) de grer l'unicit de cet identificateur  */
/*                    Pour une meme fenetre il ne peut y avoir deux     */
/*                    rectangles ayant le meme identificateur, auquel   */
/*                    cas ces deux rectangles diffrents entraineront   */
/*                    le dclenchement du meme message: WM_TT_GET_TXT.  */
/*                    Remarquons que cela peut etre utilis  dessein.  */
/*         GRECT *grect: pointe sur l'adresse du rectangle declenchant  */
/*                       il n'y a recopie de ce rectangle par EZ_GEM.   */
/*                       il vous faut donc spcifier une adresse        */
/*                       statique ou globale.                           */
/*                       IMPORTANT: les coordones de ce rectangle      */
/*                                  doivent etre en relatif par rapport */
/*                                  aux dimensions externes de la       */
/*                                  fenetre.                            */

void ToolTipDelGrect(INT16 w_ind, INT16 ident, GRECT *grect)
{ToolTipDel(Windtab[w_ind].w_h, TT_GRECT, ident, grect);
}

/*-------------------------- IdToAdrElement ---------------------------*/
/* ACTION: retourne l'adresse du Neme element d'une suite d'elements   */
/*         dont le premier long est sa longueur.                       */
/*         La fin de la liste doit etre marquee par une longueur zero. */
/* ENTREE: void *adr: adresse du premier element.                      */
/*         long elmt: indice de l'element dont on recherche l'adresse  */
/*                    option base zero.                                */
/* SORTIE: adresse de l'element. si elmt est trop grand alors c'est    */
/*                                  l'adresse suivant le dernier.      */
/*                               si elmt est trop petit, il est        */
/*                                  zero.                              */

void *IdToAdrElement(void *adr,long elmt)
{long i = 0L;
 while(*(long*)adr)
   {if (i >= elmt) return adr;
    i++;
    (unsigned long)adr += *(long*)adr;
   }
 return adr;
}

/*-------------------------- AdrElementToID ---------------------------*/
/* ACTION: retourne l'indice (option base zero) d'un element a partir  */
/*         de son adresse. (le premier long situe a cette adresse doit */
/*         etre la longueur de l'element).                             */ 
/*         La fin de la liste doit etre marquee par une longueur zero. */
/* ENTREE: void *adr_first: adresse du premier element de la liste.    */
/*         void *adr_elemt: adresse de l'element dont on recherche,    */
/*                          l'indice.                                  */
/* SORTIE: indice de l'element.si adr_elemt est trop grand alors c'est */
/*                                  l'indice suivant le dernier possi- */
/*                                  ble (en fait le nbr d'elements).   */
/*                             si adr_elemt est trop petit, alors      */
/*                                  l'indice du premier element.       */
/*         long elmt: indice de l'element dont on recherche l'adresse  */
/*                    option base zero.                                */

long AdrElementToID(void *adr_first, void *adr_elemt)
{long i = 0L;
 long adr, adr_tst;
 adr     = (long)adr_first;
 adr_tst = (long)adr_elemt;
 if (adr_tst <= adr)  return 0;
 while(*(long*)adr)
   {if (adr==adr_tst) return i;
    i++;
    adr += *(long*)adr;
   }
 return i;
}

/*---------------------- GetScrollBoxGRECT -------------------------------------------------*/
/* ACTION: retourne les dimensions des zones d'affichage des items d'une SROLLBOX           */
/*                                                                                          */
/* ENTREE: OBJECT *object: pointe sur le premier objet (objet racine) du dialogue contenant */
/*                         la SCROLLBOX.                                                    */
/*         INT16 ind_ob: indice de l'objet SCROLLBOX dans ce dialogue.                        */
/*         GRECT *grect: pointe sur le rectangle dans lequel seront retournees les          */
/*                       dimensions demandees.                                              */
/*         INT16 item: SI != -1 alors les dimensions du rectangle d'affichage de l'item       */
/*                              pointe par la variable item seront retournees.              */
/*                              si non visible il est retourne 0.                           */
/*                   SI = -1  alors les dimensions du rectangle d'affichage contenant tous  */
/*                              les items visibles est retourne (rectangle de la surface    */
/*                              d'affichage de l'objet, sans le cadre et autres fioritures) */
/* SORTIE: GRECT *: pointe sur le rectangle donne en entree.                                */
/*                  si zero c'est que l'item est non visible.                               */

GRECT *GetScrollBoxGRECT(OBJECT *object, INT16 ind_ob, GRECT *grect, INT16 item)
{INT16 fst_l, nb_l, lgn_h, l_sel;
 long param;
 XSCROLLBLK *scrollboxblk = (XSCROLLBLK*) object[ind_ob].ob_spec.userblk->ub_parm;
 INT16  old_do              = scrollboxblk->Do;
 GetScrollBoxParam(object, ind_ob, &lgn_h, 0, 0, 0, &fst_l, 0, &l_sel, 0, &param, &nb_l);
 /*................ recuperer parametres courants ..............................*/
 if (item==-1)
    {SetScrollBoxParam(object, ind_ob,-2,-2,-2,-2, -2,-2, -2, -2, grect, LST_GRECT_CLIENT_INQ);
     objc_draw(object, ind_ob, 1, 0,0,0,0); /* appel pour recuperer coordonnees  */
     /*............... replacer anciens parametres ..............................*/
     SetScrollBoxParam(object, ind_ob,-2,-2, -2,-2, -2,-2, -2,-2, (void*)param, old_do);
     return grect;
    }
 /*............. SI l'item tient dans la boite ..................................*/ 
 else if ( item >= fst_l && item < fst_l + nb_l)
    {SetScrollBoxParam(object, ind_ob,-2,-2,-2,-2, -2,-2, item,-2, grect, LST_GRECT_ITEM_INQ);
     objc_draw(object, ind_ob, 1, 0,0,0,0); /* appel pour recuperer coordonnees  */
     /*............... replacer anciens parametres ..............................*/
     SetScrollBoxParam(object, ind_ob,-2,-2, -2,-2, -2,-2, l_sel,-2, (void*)param, old_do);
     return grect;
    }
 else return 0;      
}

/*---------------------- AsciiNumberToLedNumber ------------------------*/
/* ACTION: la chaine ASCII: 0123456789 est transformee en     */
/* ENTREE: char *str: pointe sur la chaine a traiter.                   */
/* SORTIE: char *:    pointe sur la chaine traitee (meme que entree)    */

char *AsciiNumberToLedNumber(char *str)
{char *pt=str;
 while(*pt)
  {if (*pt>='0' && *pt<='9') *pt -= 32;
   pt++;
  }
 return str;  
}

/*---------------------- LedNumbertoAsciiNumber ------------------------*/
/* ACTION: la chaine ASCII:  est transformee en  0123456789   */
/* ENTREE: char *str: pointe sur la chaine a traiter.                   */
/* SORTIE: char *:    pointe sur la chaine traitee (meme que entree)    */

char *LedNumbertoAsciiNumber(char *str)
{char *pt=str;
 while(*pt)
  {if (*pt>='' && *pt<='') *pt += 32;
   pt++;
  }
 return str;  
}

/*-------------------------- EZB_FormToRec --------------------------------*/
/* ACTION: Enregistre les donnees du formulaire ds les fichiers concernes  */
/*         par ce formulaire.                                              */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre concernee par le       */
/*                    formulaire.                                          */
/*         long rec: numero de l'enregistrement (fiche) devant recevoir    */
/*                   les donnees du formulaire.                            */
/*                   -> SI -1 la fiche est rajoutee a la fin du fichier.   */
/*                   -> SINON elle remplace celle pointee par 'rec'        */
/*                   -> SI rec est plus grand que le nombre de fiches que  */
/*                         contient le fichier, la fiche est rajoutee au   */
/*                         fichier.                                        */
/* SORTIE: -1 erreur 'La base de donnee liee a ce formulaire n'existe pas' */
/*         SINON pointe sur le numero de fiche enregistre.                 */

long EZB_FormToRec(INT16 w_ind, long rec)
{OBJECT         *object; 
 EZB_FIC_STRUCT *EZB_STRUCT;
 FICSTRUCT      *FIC_STRUCT;
 CHPSTRUCT      *CHP_STRUCT;
 char           buft[256];
 long           len_fic;
 long           f_rec;
 INT16            i,chp;
 
 EZB_STRUCT = GETWIND_EZB(w_ind);
 if (EZB_STRUCT==0) return -1;
 FIC_STRUCT = EZB_STRUCT->ptFicStruct;
 CHP_STRUCT = EZB_STRUCT->ptChpStruct;
 object     = GETWINDTREE(w_ind);         /* relever premier objet */
 for (i=0; i<EZB_STRUCT->NbFic; i++)
     {len_fic = FileLen(FIC_STRUCT[i].Fstream); 
      if (rec <= -1) 
         {f_rec  = len_fic / (FIC_STRUCT[i].LenRec + 2);
         }
      else
         {f_rec  = Min(rec, len_fic / (FIC_STRUCT[i].LenRec + 2));
         }   
      EZB_STRUCT->CurRec = f_rec;
      fseek(FIC_STRUCT[i].Fstream, f_rec * (FIC_STRUCT[i].LenRec + 2), SEEK_SET);      
      for (chp=FIC_STRUCT[i].PremChp; chp<=FIC_STRUCT[i].LastChp; chp++)
          {INT16 ind_ob; 
           INT16 pt;                            
           ind_ob = CHP_STRUCT[chp].ObChp;
           if (ind_ob>-1) 
              {strcpy(buft, ObjcGetTxt (object, ind_ob) );
               pt = (INT16)strlen(buft);
               while(pt<256)
                    {buft[pt]=32;
                     pt++;
                    }
               buft[CHP_STRUCT[chp].LenChp - 1] = '|';
               memcpy(FIC_STRUCT[i].RecBuff + CHP_STRUCT[chp].DebChp, buft, CHP_STRUCT[chp].LenChp);               
              }
          } /* champ suivant    */
       FIC_STRUCT[i].RecBuff[FIC_STRUCT[i].LenRec]   = 13;
       FIC_STRUCT[i].RecBuff[FIC_STRUCT[i].LenRec+1] = 10;   
       fwrite(FIC_STRUCT[i].RecBuff,  FIC_STRUCT[i].LenRec + 2, 1, FIC_STRUCT[i].Fstream);   
       }  /* fichier suivant   */
 return f_rec;
}

/*------------------------- EZB_SetCurRec ---------------------------------*/
/* ACTION: positionne la fiche courante sur un numro de notre choix, et   */
/*         raffiche le formulaire associ.(le numero de la premiere       */
/*         commence a zero). Le numero est reajuste si trop grand.         */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre concernee par le       */
/*                    formulaire.                                          */
/*         long rec: numero de l'enregistrement (fiche) devant etre place */
/*                   comme fiche courante.                                 */
/* SORTIE: -1 erreur 'La base de donnee liee a ce formulaire n'existe pas' */
/*         SINON le numero de fiche mis en place.                          */

long EZB_SetCurRec(INT16 w_ind, long cur_rec)
{EZB_FIC_STRUCT *EZB_STRUCT;
 FICSTRUCT      *FIC_STRUCT;
 long f_rec, len_fic;
 INT16 i;
 
 EZB_STRUCT = GETWIND_EZB(w_ind);
 if (EZB_STRUCT==0) return -1;
 FIC_STRUCT = EZB_STRUCT->ptFicStruct;
 for (i=0; i<EZB_STRUCT->NbFic; i++)
     {len_fic = FileLen(FIC_STRUCT[i].Fstream);
      f_rec   = Min(cur_rec, len_fic / (FIC_STRUCT[i].LenRec + 2) -1);         
     }         
 EZB_STRUCT->CurRec = f_rec;
 EZB_RecToForm(w_ind, f_rec);
 EZB_FicChpDraw(w_ind);
return f_rec;
}

/*------------------------- EZB_GetNbRec ----------------------------------*/
/* ACTION: retourne le nombre d'enregistrements d'une structure de fichiers*/
/*         lie au formulaire de la fenetre EAZY_GEM: w_ind.               */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre concernee par le       */
/*                    formulaire.                                          */
/* SORTIE: -1 erreur 'La base de donnee liee a ce formulaire n'existe pas' */
/*         SINON le nombre d'enregistrements (ou fiches).                  */

long EZB_GetNbRec(INT16 w_ind)
{EZB_FIC_STRUCT *EZB_STRUCT;
 FICSTRUCT      *FIC_STRUCT;
 long nb_rec, len_fic;
 INT16 i;
 nb_rec = LONG_MAX;
 EZB_STRUCT = GETWIND_EZB(w_ind);
 if (EZB_STRUCT==0) return -1;
 FIC_STRUCT = EZB_STRUCT->ptFicStruct;
 for (i=0; i<EZB_STRUCT->NbFic; i++)
     {len_fic   = FileLen(FIC_STRUCT[i].Fstream);
      nb_rec    = Min(nb_rec, len_fic / (FIC_STRUCT[i].LenRec + 2));         
     }          
return nb_rec;
}

/*------------------------- EZB_FicNextRec --------------------------------*/
/* ACTION: affiche la fiche suivante, dans le formulaire.                  */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre concernee par le       */
/*                    formulaire.                                          */
/* SORTIE: -1 erreur 'La base de donnee liee a ce formulaire n'existe pas' */
/*         Sinon pointe sur le numero de fiche affichee.                   */

long EZB_FicNextRec(INT16 w_ind)
{EZB_FIC_STRUCT *EZB_STRUCT;
 FICSTRUCT      *FIC_STRUCT;
 long f_rec, rec, len_fic;
 INT16 i;
 
 EZB_STRUCT = GETWIND_EZB(w_ind);
 if (EZB_STRUCT==0) return -1;
 rec = EZB_STRUCT->CurRec + 1;
 FIC_STRUCT = EZB_STRUCT->ptFicStruct;
 for (i=0; i<EZB_STRUCT->NbFic; i++)
     {len_fic = FileLen(FIC_STRUCT[i].Fstream);
      f_rec   = Min(rec, len_fic / (FIC_STRUCT[i].LenRec + 2) -1);         
     }         
 if (f_rec != rec - 1)
    {EZB_STRUCT->CurRec = f_rec;
     EZB_RecToForm(w_ind, f_rec);
     EZB_FicChpDraw(w_ind);
    }        
return f_rec;    
}

/*------------------------- EZB_FicPrevRec --------------------------------*/
/* ACTION: affiche la fiche precedente, dans le formulaire.                */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre concernee par le       */
/*                    formulaire.                                          */
/* SORTIE: -1 erreur 'La base de donnee liee a ce formulaire n'existe pas' */
/*         Sinon pointe sur le numero de fiche affichee.                   */

long EZB_FicPrevRec(INT16 w_ind)
{long f_rec, rec;
 EZB_FIC_STRUCT *EZB_STRUCT;
 EZB_STRUCT = GETWIND_EZB(w_ind);
 if (EZB_STRUCT==0) return -1;
 rec   = EZB_STRUCT->CurRec - 1;
 f_rec = Max(-1,rec);
         
 if (f_rec > -1 && EZB_STRUCT->CurRec != f_rec)
    {EZB_STRUCT->CurRec = f_rec;
     EZB_RecToForm(w_ind, f_rec);
     EZB_FicChpDraw(w_ind);
    }        
return f_rec;    
}

/*-------------------------- EZB_FicDelRec --------------------------------*/
/* ACTION: efface la fiche courante, dans le formulaire, et le reaffiche.  */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre concernee par le       */
/*                    formulaire.                                          */
/* SORTIE: -1 erreur 'La base de donnee liee a ce formulaire n'existe pas' */
/*         Sinon pointe sur le numero de fiche affichee.                   */

long EZB_FicDelRec(INT16 w_ind)
{EZB_FIC_STRUCT *EZB_STRUCT;
 FICSTRUCT      *FIC_STRUCT;
 char           *buf_fic;
 FILE           *oldfile;
 char            buft[256]; 
 char            bufbck[256]; 
 long            rec;
 long            len_fic;
 long            len_rec;
 long            nb_rec;
 long            f_rec; 
 INT16             i;
 INT16             ok;
 long            u;
 EZB_STRUCT = GETWIND_EZB(w_ind);
 if (EZB_STRUCT==0) return -1;
 rec = EZB_STRUCT->CurRec;
 FIC_STRUCT = EZB_STRUCT->ptFicStruct;
  
 for (i=0; i<EZB_STRUCT->NbFic; i++)
     {len_fic  = FileLen(FIC_STRUCT[i].Fstream);
      len_rec  = FIC_STRUCT[i].LenRec + 2;
      nb_rec   = len_fic / len_rec;  
      f_rec    = Min(rec, nb_rec -1);  
      /*............. SI il existe encore au moins une fiche a effacer ........*/
      if (f_rec > -1)
         {/*.............. sauver l'enregistrement a effacer ........*/                                    
          strcpy(buft, FIC_STRUCT[i].FicName); 
          strcat(buft,".DEL");
          Bsave(FIC_STRUCT[i].Path, buft, FIC_STRUCT[i].RecBuff, len_rec); 
        
          buf_fic  = malloc(len_fic);
          if (buf_fic) /*>>>>.......... Si fichier peut tenir en memoire .......................*/
             {/*.......... charger tout le fichier en memoire ...........*/         
              fseek(FIC_STRUCT[i].Fstream, 0, SEEK_SET);         /* se placer au debut du fichier */          
              fread(buf_fic, len_fic, 1, FIC_STRUCT[i].Fstream); /* le lire en entier ds memoire  */
          
              /*.......... Le compacter pour effacer la fiche ...........*/       
              memmove(buf_fic + f_rec     * len_rec,
                      buf_fic + (f_rec+1) * len_rec,
                      len_fic - (f_rec+1) * len_rec
                     );
                 
              /*........... Ecraser l'ancien fichier ....................*/
              strcpy(buft, FIC_STRUCT[i].Path); 
              strcat(buft, FIC_STRUCT[i].FicName); 
              strcat(buft, ".EZB"); 
              fclose(FIC_STRUCT[i].Fstream);    /* clore l'ancien        */
          
              /*............... ouvrir en mode ecrasement ...............*/
              FIC_STRUCT[i].Fstream = fopen(buft,"wb");
              fwrite(buf_fic, len_fic - len_rec, 1, FIC_STRUCT[i].Fstream);    
              fclose(FIC_STRUCT[i].Fstream);   /* clore le mode replace  */ 
              FIC_STRUCT[i].Fstream = fopen(buft,"ab+");  
              free(buf_fic);
             } 
          else         /*>>>>.......... SINON fichier peut pas tenir en memoire ................*/
             {ok = 1;
              fclose(FIC_STRUCT[i].Fstream);         /* clore l'ancien        */
              strcpy(buft, FIC_STRUCT[i].Path);      /* le renommer en back   */
              strcat(buft, FIC_STRUCT[i].FicName); 
              strcpy(bufbck,buft);
              strcat(buft, ".EZB");
              strcat(bufbck, ".EZO");
              if (Fic_exist(bufbck,"")!= -1L && Fdelete(bufbck)!=0) ok = 0;
              if (ok)
                 {Frename(0,buft,bufbck);
                  oldfile = fopen(bufbck,"rb");
                  u = Fcreate(buft,0);
                  if (u) Fclose((INT16)u);
                  FIC_STRUCT[i].Fstream = fopen(buft,"ab+");
                  fseek(oldfile, 0, SEEK_SET);  /* se placer au debut de l'ancien fichier */
                  /*.......... reecrire les fiches jusqu'a celle a effacer exclue ........*/
                  for (u = 0; u<f_rec; u++)
                      {fread  (FIC_STRUCT[i].RecBuff, len_rec, 1, oldfile); 
                       fwrite (FIC_STRUCT[i].RecBuff, len_rec, 1, FIC_STRUCT[i].Fstream);
                      }
                  /*.......... sauter la fiche a effacer en la lisant ....................*/    
                  fread  (FIC_STRUCT[i].RecBuff, len_rec, 1, oldfile);  /* sauter la fiche a effacer */ 
                  /*.......... reecrire les autres fiches jusqu'a la fin .................*/
                  while(u<nb_rec-1)
                    {fread  (FIC_STRUCT[i].RecBuff, len_rec, 1, oldfile); 
                     fwrite (FIC_STRUCT[i].RecBuff, len_rec, 1, FIC_STRUCT[i].Fstream);
                    }   
                 } /* endif ok          */
             } /* end elseif (buf_fic) */
         } /* endif (f_rec > -1)      */                     
     } /* prochain fichier           */
     
 /*............ placer fiche qui a pris la place de l'effacee........*/    
 EZB_RecToForm(w_ind, f_rec);
 EZB_FicChpDraw(w_ind);          
 return f_rec;    
}

/*--------------------------- EZB_FicModRec -------------------------------*/
/* ACTION: Enregistre les donnees du formulaire dans la fiche courante     */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre concernee par le       */
/*                    formulaire.                                          */
/* SORTIE: -1 erreur 'La base de donnee liee a ce formulaire n'existe pas' */
/*         Sinon pointe sur le numero de fiche enregistree.                */

long EZB_FicModRec(INT16 w_ind)
{EZB_FIC_STRUCT *EZB_STRUCT;
 FICSTRUCT      *FIC_STRUCT;
 long f_rec, rec, len_fic;
 INT16 i;
 EZB_STRUCT = GETWIND_EZB(w_ind);
 if (EZB_STRUCT==0) return -1;
 rec = EZB_STRUCT->CurRec;
 FIC_STRUCT = EZB_STRUCT->ptFicStruct;
 for (i=0; i<EZB_STRUCT->NbFic; i++)
     {len_fic = FileLen(FIC_STRUCT[i].Fstream);
      f_rec   = Min(rec, len_fic / (FIC_STRUCT[i].LenRec + 2) -1);         
     }     
 EZB_FormToRec(w_ind, f_rec);          
 return f_rec;   
}
/*--------------------------- EZB_FicChpDraw ------------------------------*/
/* ACTION: Affiche les champs du formulaire lies a une base de donnee      */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre concernee par le       */
/*                    formulaire.                                          */
/* SORTIE: -1 erreur 'La base de donnee liee a ce formulaire n'existe pas' */
/*         Sinon nomre de champs affiches.                                 */

long EZB_FicChpDraw(INT16 w_ind)
{OBJECT         *object; 
 EZB_FIC_STRUCT *EZB_STRUCT;
 FICSTRUCT      *FIC_STRUCT;
 CHPSTRUCT      *CHP_STRUCT;
 INT16 ind_ob,i,chp, nb;
 EZB_STRUCT = GETWIND_EZB(w_ind);
 if (EZB_STRUCT==0) return -1;
 FIC_STRUCT = EZB_STRUCT->ptFicStruct;
 CHP_STRUCT = EZB_STRUCT->ptChpStruct;
 object     = GETWINDTREE(w_ind);         /* relever premier objet */
 nb = 0;
 /*........ effacer curseur ancien editable .......*/
 WSetCursObEditOff(w_ind, 0);
 /*........ afficher les champs ...................*/
 for (i=0; i<EZB_STRUCT->NbFic; i++)
     {for (chp=FIC_STRUCT[i].PremChp; chp<=FIC_STRUCT[i].LastChp; chp++)
          {ind_ob = CHP_STRUCT[chp].ObChp;
           if (ind_ob>-1) 
              {nb++;
               Wobjc_draw(w_ind, object, ind_ob, 5, 0);
              } 
          }  /* next champ  */
     } /* next fichier  */
 return nb;  
}


/*--------------------------- EZB_RecToForm -------------------------------*/
/* ACTION: Place les donnees d'une fiche, dans le formulaire               */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre concernee par le       */
/*                    formulaire.                                          */
/*         long rec: numero de l'enregistrement (fiche) devant etre placee */
/*                   dans le formulaire.                                   */
/*                   -> SI rec est plus grand que le nombre de fiches que  */
/*                         contient le fichier, c'est la deniere fiche qui */
/*                         est placee dans le formulaire.                  */
/*                   -> SI le fichier ne contient aucun enregistrement,    */
/*                         les champs du formulaire sont effaces.          */
/* SORTIE: -1 erreur 'La base de donnee liee a ce formulaire n'existe pas' */
/*         SINON pointe sur le numero de fiche placee dans le formulaire.  */

long EZB_RecToForm(INT16 w_ind, long rec)
{OBJECT         *object; 
 EZB_FIC_STRUCT *EZB_STRUCT;
 FICSTRUCT      *FIC_STRUCT;
 CHPSTRUCT      *CHP_STRUCT;
 char           buft[256];
 long           len_fic;
 long           f_rec;
 INT16            i,chp;
 EZB_STRUCT = GETWIND_EZB(w_ind);
 if (EZB_STRUCT==0) return -1;
 FIC_STRUCT = EZB_STRUCT->ptFicStruct;
 CHP_STRUCT = EZB_STRUCT->ptChpStruct;
 object     = GETWINDTREE(w_ind);         /* relever premier objet */
 
 for (i=0; i<EZB_STRUCT->NbFic; i++)
     {len_fic = FileLen(FIC_STRUCT[i].Fstream);
      f_rec   = Min(rec, len_fic / (FIC_STRUCT[i].LenRec + 2) -1);
      if (f_rec==-1)
         {for (chp=FIC_STRUCT[i].PremChp; chp<=FIC_STRUCT[i].LastChp; chp++)
              {INT16 ind_ob;
               ind_ob = CHP_STRUCT[chp].ObChp;
               if (ind_ob>-1) 
                  {ObjcSetTxt (object, ind_ob, "");                  
                  }
              } 
         }
      else
         {fseek(FIC_STRUCT[i].Fstream, f_rec * (FIC_STRUCT[i].LenRec + 2), SEEK_SET);
          fread(FIC_STRUCT[i].RecBuff, FIC_STRUCT[i].LenRec, 1, FIC_STRUCT[i].Fstream);
          for (chp=FIC_STRUCT[i].PremChp; chp<=FIC_STRUCT[i].LastChp; chp++)
              {INT16 ind_ob;                             
               ind_ob = CHP_STRUCT[chp].ObChp;
               if (ind_ob>-1) 
                  {memcpy(buft, FIC_STRUCT[i].RecBuff + CHP_STRUCT[chp].DebChp, CHP_STRUCT[chp].LenChp);
                   buft[CHP_STRUCT[chp].LenChp - 1] = 0;
                   StrTrimEnd(buft);
                   ObjcSetTxt (object, ind_ob, buft);                   
                  }
              } 
         }         
     }
 return f_rec;      
}

/*------------------------- EZB_CreateStruct -----------------------------*/
/* ACTION: verifie si il existe un script de base de donnees associees au */
/*         formulaire de cette fenetre, si c'est le cas cree toutes les   */
/*         les structures necessaires a la gestion des bases de donnees   */
/*         ratachees a ce formulaire, ouvre les fichiers necessaires.     */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre concernee par le      */
/*         formulaire.                                                    */
/* SORTIE: void*: pointeur sur la structure de gestion de base            */
/*                de donnee cree et mise en place.                        */
/*                Si zero ou -1 .... -20 erreur.                          */
/* IMPORTANT: il est imperatif de detruire les structures de base de      */
/*            donnees, avant la fin du programme, en utilisant la         */
/*            fonction: EZB_DestroyStruct();                              */

void *EZB_CreateStruct(INT16 w_ind)
{OBJECT         *ob_script; 
 EZB_FIC_STRUCT *EZB_STRUCT;
 FICSTRUCT      *FIC_STRUCT;
 INT16            i;
 char           path[256];
 INT16            fh;
 
 Windtab[w_ind].EZB_struct = 0; /* initialiser sur zero                  */
 EZB_STRUCT = 0;
 /*............ si lien possible vers script de base de donnee...........*/
 /*                   trouve dans le formulaire                          */  
 ob_script   =  EZB_GetFormScriptLink(w_ind); if (ob_script == 0) return 0;
 EZB_STRUCT  =  EZB_OpenFormFic(w_ind, ob_script);
 /*.............. ouvrir les fichiers correspondants ................*/
 FIC_STRUCT = EZB_STRUCT->ptFicStruct;
 for (i=0; i<EZB_STRUCT->NbFic; i++)
     {strcpy(path,FIC_STRUCT[i].Path);
      strcat(path,FIC_STRUCT[i].FicName);
      strcat(path,".EZB");
      if (Fic_exist(path,"")==-1)
         {fh = (INT16)Fcreate(path,0);
          if (fh) Fclose(fh);
         }
      FIC_STRUCT[i].Fstream = fopen(path, "ab+");
      if (FIC_STRUCT[i].Fstream == 0) return (EZB_FIC_STRUCT*)-1;
     }
     
 Windtab[w_ind].EZB_struct = EZB_STRUCT;
 return EZB_STRUCT;
}

/*---------------------------- EZB_DestroyStruct -------------------------*/
/* ACTION: fonction servant a detruire proprement toutes les structures   */
/*         de base de donnee mise en place avec la fonction:              */
/*         EZB_CreateStruct();                                            */
/*         Cette fonction ferme aussi tous les fichiers ouverts.          */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre concernee par le      */
/*         formulaire.                                                    */

INT16 EZB_DestroyStruct(INT16 w_ind)
{FICSTRUCT      *FIC_STRUCT; 
 EZB_FIC_STRUCT *EZB_STRUCT;
 INT16 i; 
 EZB_STRUCT = GETWIND_EZB(w_ind);
 
 if (EZB_STRUCT)
    {FIC_STRUCT = EZB_STRUCT->ptFicStruct;
     for (i=0; i<EZB_STRUCT->NbFic; i++)
         {fclose(FIC_STRUCT[i].Fstream);      
         }
     EZB_CloseFormFic(EZB_STRUCT); 
    }        
 Windtab[w_ind].EZB_struct = 0;
 return 1;
}

/*---------------------------- EZB_OpenFormFic ---------------------------*/
/* ACTION: reserve et cree en memoire une structure permettant de lier    */
/*         les zones d'affichage et saisie du formulaire associe a la     */
/*         fenetre, aux champs des fichiers precises par le script.       */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre concernee par le      */
/*         formulaire.                                                    */     
/*         OBJECT *ob_script: objet racine contenant les chaines du       */
/*                            script associe au formulaire de la fenetre. */
/* SORTIE: void* pointeur sur la structure de type EZB_FIC_STRUCT cree et */
/*               reservee en memoire par la fonction. (ne pas oublier de  */
/*               la liberer avant la fin du programme) en utilisant la    */
/*               fonction:  EZB_CloseFormFic();                           */
/* RAPPEL:   Rappel sur les structures de fichiers.                       */
/*                                                                        */
/* typedef struct                                                         */
/*    {long CurRec;      N enregistrement courant.                       */
/*     INT16 PremChp;      indice premier champ dans CHPSTRUCT[PremChp].    */ 
/*     INT16 LastChp;      indice dernier champ dans CHPSTRUCT[LastChp].    */
/*     char *RecBuff;    buffer contenant l'enregistrement CurRec         */
/*     char Path[256];   path du fichier                                  */
/*     char FicName[64]; nom du fichier                                   */
/*     FILE *Fstream;    structure alouee lors ouverture                  */
/*     long LenRec;      longueur d'un enregistrement                     */
/*    }FICSTRUCT;                                                         */
/*                                                                        */
/* typedef struct                                                         */
/*    {INT16  IndFic;   indice de la structure de fichier FICSTRUCT[IndFic] */ 
/*     INT16  ObChp;    indice OBJET champ de saisie                        */
/*     long DebChp;   indice du premier octet du champ                    */
/*     long LenChp;   longueur du champ                                   */
/*    }CHPSTRUCT;                                                         */
/*                                                                        */
/* typedef struct                                                         */
/*    {OBJECT *ObScript;         container de script                      */
/*     long CurRec;              enregistrement courant                   */
/*     long NbFic;               nombre de fichiers concernes et ouverts  */ 
/*     long NbChp;               nombre de structures de champs           */
/*     FICSTRUCT *ptFicStruct;   pointeur sur zone structure de fichiers  */
/*     CHPSTRUCT *ptChpStruct;   pointeur sur zone structure de champs    */
/*     char *PtRecBuff;          pointeur sur zone buffer enregistrements */ 
/*    }EZB_FIC_STRUCT;                                                    */

void *EZB_OpenFormFic(INT16 w_ind, OBJECT *ob_script)

{char *pt_str,*buf_fic;
 char buffic[32*64];       /* buffer de stockage des noms de fichier         */
 char path[256]; 
 char argu[64];            /* buffer dans lequel sont extraits les arguments */
 char inst[64];
 char *ptfic[32];          /* tableau de pointeurs sur les noms de fichier   */
 INT16 nb_chp=0;
 INT16 nb_fic=0;
 INT16 i,idem,indob;
 long len_mem;
 long len_fic;

 
 EZB_FIC_STRUCT *EZB_STRUCT;
 FICSTRUCT      *FIC_STRUCT;
 CHPSTRUCT      *CHP_STRUCT;
 /*........................... ANALYSER LE FORMULAIRE SCRIPT .................*/
 /*                 relever les noms des differents fichiers concernes        */
 /*                 compter le nombre de fichiers du formulaire               */
 /*                 compter le nombre de champs de ce formulaire              */
 if (ob_script<=0) return 0; 
 indob = -1;
 *argu = 0;
 ptfic[nb_fic] = buffic;
 do {indob++;
     /*.................. Si objet type SCRIPTLINK .................*/
     if (ob_script[indob].ob_type==G_STRING )
        {pt_str = ObjcGetTxt(ob_script,indob);        
         pt_str = GetArgument(pt_str, inst);     /* recuperer prem arg: OBJET        */
         pt_str = GetArgument(pt_str, argu);     /* recuperer 2eme arg: 01           */
         if (*argu && strcmp(inst,"OBJET")==0)                          
            {pt_str = GetArgument(pt_str, argu); /* recherche 2eme arg: FICHIER.EZB  */
             if (*argu)
                {Enleve_ext(argu);
                 /*........... rechercher si fichier idem ....................*/
                 /*            deja note si c'est le cas on                   */
                 /*            arrete le test car il y est deja               */
                 idem = 0;                    /* a priori fichier pas idem    */
                 for (i=0; i<nb_fic; i++)
                     {if (strcmp (argu, ptfic[i]) == 0) 
                         {idem=1;
                          break;
                         }
                     }
                 /*........... Si pas de fichier idem alors ........*/     
                 /*            noter nom du fichier ds table        */
                 if (idem==0)
                    {strcpy( ptfic[nb_fic], argu );                     
                     ptfic[nb_fic+1] = ptfic[nb_fic] + 1 + strlen(argu);
                     nb_fic++;
                    } 
                }  /* endif *buft   */
            }     /* endif fic_str */
         nb_chp++;    
        } /* objet champ suivant   */
     } while( ! (ob_script[indob].ob_flags & LASTOB));
     
/*................reserver memoire structure ........................*/      
len_mem = sizeof (EZB_FIC_STRUCT)   +        /* header               */
          sizeof (FICSTRUCT)*nb_fic +        /* structures fichiers  */
          sizeof (CHPSTRUCT)*nb_chp;         /* structures de champ  */ 
EZB_STRUCT = (EZB_FIC_STRUCT*) malloc(len_mem); if (EZB_STRUCT==0) return 0;

FIC_STRUCT = (FICSTRUCT*)((long)EZB_STRUCT + sizeof (EZB_FIC_STRUCT));
CHP_STRUCT = (CHPSTRUCT*)((long)FIC_STRUCT + sizeof (FICSTRUCT) * nb_fic);

EZB_STRUCT->ObScript     = ob_script;
EZB_STRUCT->NbFic        = nb_fic;
EZB_STRUCT->NbChp        = nb_chp;
EZB_STRUCT->ptFicStruct  = FIC_STRUCT;
EZB_STRUCT->ptChpStruct  = CHP_STRUCT; 
EZB_STRUCT->CurRec       = 0;    
/*.......... initialiser les noms de fichiers  ouvrir ..................*/
/*           on se sert provisoirement de EZB_STRUCT->CurRec             */
/*           pour pointer le CHP_STRUCT[] en cours                       */
                                                                      
len_mem = 0;       /* accumulera memoire necessaire pour enregistrements */
for(i=0; i<nb_fic; i++)
   {strcpy(FIC_STRUCT[i].FicName, ptfic[i]);
    strcpy(argu, ptfic[i]);               /*-> relever nom du fichier BASE   */
    strcat(argu, ".BDF");                 /* rajouter extension definition   */
    GetPathRsc(Windtab[w_ind].DlgVar.AdrRsc, path);         /* recuperer path ressource */
    PathNomToNomFic(path, 0);                               /* y enlever le nom du path */
    len_fic = FindFicSys(path, NomAppli, argu);             /* rechercher ce fichier           */
    if (len_fic>0)                                          /* Si trouve charger et Analyse    */ 
       {buf_fic = malloc(len_fic+1); if (buf_fic==0) return 0;        
        Bload(path, argu, buf_fic);  
        buf_fic[len_fic] = 0;
        strcpy(FIC_STRUCT[i].Path, path);
        FIC_STRUCT[i].PremChp = (INT16)EZB_STRUCT->CurRec;            
        FIC_STRUCT[i].LenRec  = EZB_Init_CHPSTRUCT(w_ind, EZB_STRUCT, i, buf_fic);
        FIC_STRUCT[i].LastChp = (INT16)EZB_STRUCT->CurRec - 1;   
        len_mem += FIC_STRUCT[i].LenRec + 2;        
        free( buf_fic );                   
       } /* endif fichier trouve */    
   }  /* next fichier           */
   
EZB_STRUCT->CurRec       = 0;     /* restaurer valeur par defaut       */
/*.......... reserver memoire des buffers d'enregistrement ............*/
/*                 et initialiser les pointeurs dessus                 */

EZB_STRUCT->PtRecBuff  = malloc(len_mem); if (EZB_STRUCT->PtRecBuff==0) return 0;
len_mem = 0;
for(i=0; i<nb_fic; i++)
   {FIC_STRUCT[i].RecBuff = EZB_STRUCT->PtRecBuff + len_mem;
    len_mem += FIC_STRUCT[i].LenRec + 2;        
   }  /* next fichier           */
if (EZB_STRUCT->PtRecBuff) memset(EZB_STRUCT->PtRecBuff, 32, len_mem);   
return EZB_STRUCT;   
}

/*---------------------------- EZB_CloseFormFic ---------------------------*/
INT16 EZB_CloseFormFic(EZB_FIC_STRUCT *EZB_STRUCT)
{if (EZB_STRUCT)
    {if (EZB_STRUCT->PtRecBuff) free(EZB_STRUCT->PtRecBuff);
     free(EZB_STRUCT);
     return 1;
    }
 return 0;   
}

/*------------------------ EZB_Init_CHPSTRUCT ---------------------------*/
/* ACTION: construit et rempli les structures de champ  partir du       */
/*         fichier de definition, et du script.                          */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre concernee par le     */
/*         formulaire.                                                   */
/*         EZB_FIC_STRUCT *EZB_STRUCT: structure memoire gestion de      */
/*                                     fichiers.                         */
/*         INT16 fic: indice de ce fichier dans la table des fichiers.     */
/*         char *fic_def: zone memoire ou sont stockes les definitions  */
/*                        de la structure d'enregistrement du fichier.   */
/*                        c'est la recopie en memoire du fichier de      */
/*                        definition.                                    */
/* SORTIE: long: longueur d'un enregistrement.                           */

long EZB_Init_CHPSTRUCT( INT16 w_ind, EZB_FIC_STRUCT *EZB_STRUCT, INT16 fic, char *fic_def) 
{OBJECT *object, *ob_scrpt;
 INT16 indscpt, indob, indchp;
 long lenrec;
 char *ptdef, *ptdef_end, *pt;
 
 char args[64];      /* buff ou sera extrait noms des champs du formulaire script           */
 char argd[64];      /* buff ou sera extrait noms des champs du fichier de def.             */
 char argr[64];      /* buff ou sera extrait les ref champ du formulaire des champs  script */
 char argf[64];      /* buff ou sera extrait les ref dans champ du formulaire               */
 char argn[64];      /* buff ou sera extrait les tailles champs definies dans ficdef        */    
 char inst[64];      /* buff ou sera extrait le nom de l'instruction                        */
 FICSTRUCT *FIC_STRUCT;
 CHPSTRUCT *CHP_STRUCT;
/*............. initialiser quelques pointeurs et variables ................*/ 
 FIC_STRUCT  = EZB_STRUCT->ptFicStruct;
 CHP_STRUCT  = EZB_STRUCT->ptChpStruct;
 object      = GETWINDTREE(w_ind);       /* relever 1er objet formulaire              */ 
 ob_scrpt    = EZB_STRUCT->ObScript;     /* relever 1er objet script                  */  
 indchp      = (INT16)EZB_STRUCT->CurRec;  /* utilisation provisoire = champ en cours   */
 lenrec      = 0;
/*.................. POUR CHAQUE CHAMP DU FICHIER DE DEFINITION ..........*/              
/*                regarder si il est concerne par un champ du script      */
/*              si oui rechercher le champ formulaire correspondant       */
/*                                                                        */
/* RAPPEL: Reference champ formulaire:      "Ref1"                        */
/*         Champ de Script:                 "Ref1,KI_CIVIL,NumSecu"       */
/*         Champ du fichier de definition:  "NumSecu,15,Int;"             */

ptdef       = fic_def;
ptdef_end   = NextBreakChar(ptdef, ";");
while (*ptdef_end)
 {*ptdef_end=0;
  /*......... relever arguments champ fichier de def................*/
  pt = GetArgument(ptdef, argd); if (*argd==0) return -4L; /* nom du champ def */
  GetArgument(pt, argn);         if (*argn==0) return -5L; /* longueur champ   */
  
  /*......... POUR CHAQUE CHAMP DU FORMULAIRE DE SCRIPT .............*/     
  /*              voir si il y a un du meme nom que                  */
  /*              le nom de la definition en cours.                  */  
  indscpt=-1;      
  do {indscpt++;
      if (ob_scrpt[indscpt].ob_type==G_STRING )
         {/*......... aller chercher nom du champ fichier def .........*/
          pt = ObjcGetTxt(ob_scrpt,indscpt);
          pt = GetArgument(pt, inst); if (*inst==0) return -1L; /* Nom instruction: OBJET */
          if (strcmp(inst, "OBJET")==0) /* SI chaine de parametrage de champ                  */
             {pt = GetArgument(pt, argr); if (*argr==0) return -2L; /* ref au chp du formul.  */  
              pt = GetArgument(pt, args); if (*args==0) return -3L; /* nom fichier            */
              pt = GetArgument(pt, args); if (*args==0) return -4L; /* nom champ              */
          
          
              if (strcmp(args, argd)==0)
                 {/*.... SI CE CHAMP SCRIPT FAIT REFERENCE A CE CHAMP DE FICHIER ....*/
                  /*               noter les  caracteristiques du champ              */                     
                  CHP_STRUCT[indchp].IndFic = fic;
                  CHP_STRUCT[indchp].ObChp  = -1;       /* a priori pas de ref champ OBJECT */
                  CHP_STRUCT[indchp].DebChp = lenrec;
                  CHP_STRUCT[indchp].LenChp = atoi(argn)+1;  /* +1 car separateur     */
              
                  /*....... explorer le formulaire pour voir si la reference .........*/
                  /*      du champ script etudie, est dans un objet du formulaire     */                 
                  indob = -1;
                  do
                    {indob++;
                     /*...................si chp formulaire trouv....................*/
                     /*                 noter la reference a l'OBJECT                 */
                     if (! (object[indob].ob_state & 0x8000))  /* si pas string bulle */
                        {GetArgument(ObjcGetTxt(object,indob), argf);                  
                         if (*argf && strcmp(argf,argr)==0) 
                            {CHP_STRUCT[indchp].ObChp    = indob;                                       
                            } 
                        }                         
                    }while( ! (object[indob].ob_flags & LASTOB)); 
                  indchp++;          
                 } /* endif (strcmp(args,argd)==0)           */             
             } /* endif (strcmp(inst, "OBJET")==0)        */  
         } /* endif ob_scrpt[indscpt].ob_type==G_STRING  */
     }while( ! (ob_scrpt[indscpt].ob_flags & LASTOB));    
  /*........... CHAMP DEF SUIVANT ..........*/   
  lenrec += atoi(argn)+1;                   /* incrementer longueur enregistrement */
  *ptdef_end = ';';                         /* remettre fin de ligne normal        */
  ptdef = ptdef_end +1;                     /* definition suivante                 */
  ptdef_end   = NextBreakChar(ptdef,";");   /* fin de ligne suivante               */
 } /* end while *ptdef_end */  
 FIC_STRUCT[fic].LenRec = lenrec; 
 EZB_STRUCT->CurRec     = indchp;     /* utilisation provisoire = champ en cours   */     
 return lenrec; 
}             

/*--------------------------- EZB_GetFormScriptLink --------------------*/
/* ACTION: cherche si le formulaire de la fenetre comporte un script de */
/*         definition de base de donnee.                                */
/* ENTREE: ind w_ind: indice EAZY_GEM de la fenetre.                    */
/* SORTIE: OBJECT * adresse ressource contenant les scripts             */
/*                  zero si non trouv.                                 */ 
OBJECT *EZB_GetFormScriptLink(INT16 w_ind)
{OBJECT *object;
 char *scrptlinktxt;
 INT16 o, xob_type;
 object = GETWINDTREE(w_ind);         /* relever premier objet */
 o = -1;
 do {o++;
     /*.................. Si objet type SCRIPTLINK .................*/
     xob_type=GET_XOBTYPE(object,o);
     if (xob_type == SCRIPT_LINK || xob_type == TAB_LINK_CONT)
        {scrptlinktxt = ObjcGetTxt(object,o);         
         if (scrptlinktxt) 
            {if (xob_type == SCRIPT_LINK ) object[o].ob_flags |= HIDETREE;
             scrptlinktxt = StrTrimDeb(scrptlinktxt);
             StrTrimEnd(scrptlinktxt);  
             return  EZB_GetScriptContainer(w_ind, scrptlinktxt);   
            }      
        }     
     } while( ! (object[o].ob_flags & LASTOB)); 
  return 0;
}

/*------------------------- EZB_GetScriptContainer ---------------------*/
OBJECT *EZB_GetScriptContainer(INT16 w_ind, char *scriptlink)
{void *adr_rsc;
 INT16 t;
 INT16 ntree;
 INT16 xob_type;
 OBJECT *object;
 char *linktarget;
 adr_rsc  = Windtab[w_ind].DlgVar.AdrRsc;
 ntree    = Windtab[w_ind].DlgVar.NbrTree;
 
 for (t=0; t<ntree; t++)
     {/*....... pour toutes les ressources rechercher .....*/
      /*        un objet type container de script          */                                        
      xrsrc_gaddr (R_TREE, t, &object, adr_rsc);
      xob_type=GET_XOBTYPE(object,0);
      if (xob_type==SCRIPT_TARGET)
         {linktarget = ObjcGetTxt(object,0);
          if (strcmp(linktarget, scriptlink)==0)  return object;
         }
     }
 return 0;         
}


/*----------------------------- GetPathRsc -------------------------------*/
/* ACTION: retourne le path de chargement de la ressource dont l'adresse  */
/*         est specifiee en entree.                                       */
/* ENTREE: void *adr_rsc: pointeur sur l'adresse de la ressource.         */
/*         char *path: chaine qui recevra la copie du path de ressource.  */
/* SORTIE: char *: adresse de la chaine d'entree                          */
/*                 SI zero pas de ressource en memoire.                   */

char *GetPathRsc(void *adr_rsc, char *path)
{if ((ULONG)adr_rsc>256) 
    {strcpy(path, (char*)adr_rsc - 256);
     return path;
    }
 else 
    {return 0;
    }
}

/*----------------------------- FileLen ----------------------------------*/
/* ACTION: donne la longueur d'un fichier type FILE.                      */
/* ENTREE: FILE *stream: pointeur sur la structure FILE alouee par le     */
/*         systeme lors creation ou ouverture du fichier.                 */
/* SORTIE: longueur du fichier.                                           */

long FileLen(FILE *stream)
{long pos,sav_pos;
 fgetpos(stream,(fpos_t*)&sav_pos);  /*  sauver la position            */
 fseek(stream,0,SEEK_END);           /*  se mettre a la fin du fichier */
 fgetpos(stream,(fpos_t*)&pos);      /*  demander la position          */
 fseek(stream,0,SEEK_END);           /*  se mettre a la fin du fichier */
 fseek(stream,sav_pos,SEEK_CUR);     /*  restituer position            */
 return pos;
}



/*--------------------------- Extrait_mot ---------------------------------------*/
/* ACTION:  prend tous les caracteres de str_srce et tant qu'ils n'appartiennent */
/*          pas  la chaine d'invalidite ils sont recopis dans  str_dest        */
/*          la chaine de break l'emporte sur la chaine de validit               */
/*                                                                               */
/* ENTREE: *strdest    pointe sur chaine ou sont places les caracteres extraits  */
/*         *strsrc     pointe sur chaine dont il faut extraire le mot            */
/*         *str_valid  pointe sur chaine specifiant les caracteres valides       */
/*                     si vide alors tous les caracteres sont acceptes           */
/*                     si zero alors tous les caracteres sont acceptes           */
/*         *str_break   pointe sur chaine specifiant les caracteres qui doivent  */
/*                      marquer la fin du mot                                    */
/* SORTIE: *str pointe sur le premier car n'appartenant pas  la chaine extraite */

char *Extrait_mot(char *str_dest, char *str_srce, char *str_valid,
                  char *str_break)
{if (str_valid && *str_valid==0) str_valid = 0;
 while (strchr(str_break,*str_srce)==0    /* si pas car de fin de chaine         */
               && *str_srce)              /* et 0 de fin pas atteint             */
        {if (str_valid==0  ||                 /* si str validite non definie ou  */
             strchr(str_valid,*str_srce))     /* si le car lui appartient        */
            {*str_dest=*str_srce;             /* copier le caractere             */
             str_dest++;
            }
         str_srce++;
        }
 *str_dest=0;                                  /* placer le zero de fin         */
 return str_srce;
}

/*--------------------------- NextBreakChar ------------------------------------*/
/* ACTION: fait avancer le pointeur de chaine jusqu'u premier caractre        */
/*         invalide trouve.                                                     */ 
/* ENTREE: *str         pointe sur chaine  analyser                            */
/*         *str_break   pointe sur chaine specifiant les caracteres invalides   */
/* SORTIE: *str         pointe sur le caractere invalide                        */

char *NextBreakChar(char *str, char *str_break)
{while (strchr(str_break,*str)==0     /* tant que car de chaine est valide   */
               && *str) str++;        /* et 0 de fin non atteint poursuivre  */
 return str;
}

/*--------------------------- SendExeFunc ---------------------------*/
/* ACTION: envoie a l'application de destination app_id, un message  */
/*         d'execution de fonction.                                  */
/* ENTREE: INT16 app_id: identificateur GEM de l'application a qui le  */
/*                     message est destin.                          */
/*         INT16 num_func: numero de fonction que l'on desire executer */
/*                       dans cette application .                    */
/*          long user: parametre que l'on peut passer a la fonction  */
/*                     ce parametre se retrouvera en:                */
/*                     msgbuf[W_G] et msgbuf[H_G].                   */  

void SendExeFunc(INT16 app_id, INT16 num_func, long user)
{INT16 msgbuf[8];
 msgbuf[MESG]= WM_EXEFUNC;      /* message pour executer une fonction   */ 
 msgbuf[APPL]= Appl_id;         /* iddentificateur de l'appelant (moi)  */
 msgbuf[SUPL]= 0;               /* message sans surplus                 */
 msgbuf[WHND]= 0;               /* message provenant d'une ressource    */
 msgbuf[X_G] = 0;               /* indice objet declenchant le message  */
 msgbuf[Y_G] = num_func;        /* numero fonction                      */         
 *(long*)(&msgbuf[W_G]) = user; /* placer le parametre libre            */  
 appl_write(app_id, 16, msgbuf ); 
}
/*---------------------- WindDialogConstruct ---------------------------*/
/* ACTION: integre un dialogue en fenetre.                              */
/* ENTREE: INT16 w_ind: indice de notre fenetre pointe sur bonne          */
/*                    structure Windtab[wind]                           */
/*         void *adr_rsc: adresse de chargement de la ressource.        */
/*         INT16 tree:      numero de l'arbre a integrer.                 */
/*         INT16 type:      type d'arbre a integrer RSC_DIAL ou TOOL_BAR  */
/*         EVNT_O *Evnt: pointe sur structure de flux evenementiel      */
/* SORTIE: Evnt->evnt = WM_ABORT; si echec / inchang si tout est ok    */
/*         Evnt->pipe[X_B]  Evnt->pipe[H_B] initialise sur dimenssions */
/*                                         d'ouverture de la ressource  */

INT16 WindDialogConstruct(INT16 w_ind, void *adr_rsc, INT16 tree, INT16 type, 
                        EVNT_O *Evnt )
{if (w_ind   <= -1)         return WM_ABORT;
 if (adr_rsc < (void*) 24L) return WM_ABORT;
 Windtab[w_ind].DlgVar.AdrRsc  = adr_rsc;
 Windtab[w_ind].DlgVar.type    = type;
 Windtab[w_ind].DlgVar.NumTree = tree;
 Evnt->pipe[WHND]              = Windtab[w_ind].w_h;
 return Xform_construct(w_ind, Evnt);   
}            
/*---------------------- DiderotHelpReply -------------------------------*/
/* ACTION: repond au message AID_REQUEST envoy par DIDEROT lorsqu'il    */
/*         doit afficher une aide. Cette fonction rempli automatiquement */
/*         les membres de la structure DID_HELP *VIEWHLP: dont on fourni */
/*         en entree l'adresse. Le fichier d'aide est cherche dans les   */
/*         repertoires systemes de l'application.                        */
/*         Au premier affichage de la fenetre d'aide ses dimensions sont */
/*         automatiquement ajustees pour qu'elle s'affiche de facon a ne */
/*         pas recouvrir la fenetre demandeuse d'aide.                   */
/*                                                                       */ 
/* ENTREE: w_ind: indice EAZY_GEM de la fenetre correspondant au fichier */
/*                d'aide, specifie par la variable: char *fic_aide       */
/*                Si ce n'est pas la fenetre pour laquelle DIDEROT deman-*/
/*                de une aide, il ne se passera rien et la fonction      */
/*                retourne avec 0;                                       */   
/*         EVNT_O *Evnt: variable de flux evenementiel.                  */
/*         DID_HELP *VIEWHLP: pointeur sur la structure de retour, que   */
/*                            l'on va renvoyer a DIDEROT afin qu'il      */
/*                            afficher l'aide demandee.                  */ 
/*         char *fic_aide: nom du fichier d'aide. il sera cherch dans   */
/*                         les repertoires systemes de l'application.    */
/*         INT16 ref: numero de la reference a afficher de ce fichier      */
/*                  d'aide.                                              */
/*         INT16 w, h: largeur et hauteur que l'on veut pour l'affichage   */
/*                   de la fenetre d'aide.                               */
/* RETOUR:  1 tout est OK                                                */
/*          0 l'indice de fenetre fourni en entre n'est pas le bon.      */
/*         -1 l'application DIDEROT non presente.                        */
/*         -2 le fichier d'aide fourni en entre n'est pas trouve.        */

INT16 DiderotHelpReply(INT16 w_ind, EVNT_O *Evnt, DID_HELP *VIEWHLP, char *fic_aide, INT16 ref, INT16 w, INT16 h)
{VRECT vrect;
 GRECT scrgrect;
 INT16 msgbuf[8], acc_id;
 /*...... erreur si fenetre pas celle .............*/
 /*    pour laquelle DIDEROT demande une aide      */
 if (Windtab[w_ind].w_h != Evnt->pipe[WHND])  return  0;              
 if( (acc_id=appl_find("DIDEROT ")) < 0 )     return -1; 
 
 /*........... recherchons fichier d'aide .........*/
 /*          dans notre fichier systeme            */
 VIEWHLP->Aid_file[0]=0; /* debuter recherche au niveau appli  */
 if (FindFicSys( VIEWHLP->Aid_file, NomAppli, fic_aide )<0) return -2; 
 strcat( VIEWHLP->Aid_file, fic_aide );
 VIEWHLP->Ref=ref;   
              
 /*........... afficher fenetre aide a droite ou gauche .........*/
 wind_get(0,4,&scrgrect.g_x,&scrgrect.g_y,&scrgrect.g_w,&scrgrect.g_h);
 GRECT_to_VRECT(&Windtab[w_ind].ExtGrectUse, &vrect); 
 if (vrect.left < Ecran_l - vrect.right)    /* afficher a droite  */
    {VIEWHLP->x_win=vrect.right+4;
     VIEWHLP->w_win=Min(w,Ecran_l - vrect.right-4);
    }
 else                                       /* afficher a gauche  */    
    {VIEWHLP->x_win=0;
     VIEWHLP->w_win=Min(w,vrect.left-4);
    }
 VIEWHLP->y_win=scrgrect.g_y;                   /* position Y de la fenetre d'aide */
 VIEWHLP->h_win=Min(h,Ecran_h-scrgrect.g_y);    /* hauteur de la fenetre d'aide    */
 VIEWHLP->w_h=Windtab[w_ind].w_h;               /* placer handle de notre fenetre  */
 /*.............. envoyer message vers DIDEROT ..................................*/ 
 wind_update(BEG_UPDATE);             /* bloquer le GEM.                         */  
 msgbuf[MESG]=AID_SEND;               /* message reponse  pour DIDEROT.          */
 msgbuf[APPL]=Appl_id;                /* iddentificateur de l'appelant (moi)     */
 msgbuf[SUPL]=0;                      /* message sans surplus                    */
 *(long*)(&msgbuf[3])=(long)VIEWHLP;  /* placer adresse de la structure VIEWHLP  */             
 appl_write(acc_id,16,msgbuf);        /* envoyer message.                        */
 wind_update(END_UPDATE);             /* debloquer le GEM.                       */
 return 1;
}
/*---------------------- AdaptListBoxToWindHeight -----------------------*/
/* ACTION: adapte une LISTBOX de maniere a ce qu'elle occupe toute la    */
/*         la hauteur d'une fenetre dont les dimenssions exterieures     */
/*         donnees (ou pas) dans les limites fixees par maxcases.        */
/* ENTREE: INT16 w_ind, indice EAZY_GEM de la fenetre ou se trouve la      */
/*                    LISTBOX.                                           */
/*         INT16 ob_list, indice de l'objet LISTBOX dans l'arbre de        */
/*                      ressource de la fenetre.                         */
/*         INT16 maxcases, Maximum de cases que l'on autorise.             */
/*         GRECT *ext_grect, rectangle exterieur de la fenetre.          */
/*                           Si 0 la fonction utilise le dernier que la  */
/*                                la fenetre a stocke dans sa structure  */
/*                                de fenetre: Windtab[w_ind].GemWorkGrect*/
/*                           Sinon c'est celui passe en entree qui est   */
/*                                 utilise.                              */

void AdaptListBoxToWindHeight(INT16 w_ind, INT16 ob_list, INT16 maxcases, GRECT *ext_grect)
{GRECT wgrect,*grect;
 DLG_VAR *dlg;
 INT16 i,oby0,oby,h_lign,nbcases,nbitem,first;
 dlg = &Windtab[w_ind].DlgVar;
 if (ext_grect) grect = ext_grect;
 else           grect = &Windtab[w_ind].GemWorkGrect;
/*.............. Adapter hauteur des LISTBOX ..............................*/
 WindGemBorderToEZWork(Windtab[w_ind].w_attr, grect, &wgrect);
 objc_offset(dlg->tree,ob_list,&i,&oby);   /* recuperer position y de la list box   */
 objc_offset(dlg->tree,0,&i,&oby0);        /* recuperer position y de l'objet zero  */
 oby -= oby0;                              /* ofset par rapport espace de travail   */
 
 GetListBoxParam(dlg->tree,ob_list,0,&first,0,&nbitem,&h_lign,0);
 maxcases=Min(maxcases,nbitem+1);
 oby = wgrect.g_h - oby - 5;  
 nbcases = oby / h_lign ;
 nbcases = Max(2,Min(nbcases,maxcases));
 first = Min(nbitem-(nbcases-1),first);
 SetListBoxParam(dlg->tree, ob_list,-2,first,nbcases,-2,-2,(void*)-2);
}

/*--------------------- GetFreeString ------------------------------------*/
/* ACTION: Retourne l'adresse du tableau de pointeurs de freestring, d'une*/
/*         ressource.                                                     */
/*         Il est ensuite possible d'acceder a chaque chaine de cette     */
/*         table par son indice. (utiliser pour les indices la table      */
/*                                symbolique .H que genere Interface.)    */                                          
/* ENTREE: void *adr_rsc, adresse ou a ete chargee la ressource dont on   */
/*                        cherche la table de FreeString.                 */
/* SORTIE: char **, pointe sur la table de pointeur de chaine.            */

char **GetFreeStringTab(void *adr_rsc)
{char **pt;
if (adr_rsc) 
   {xrsrc_gaddr(R_FRSTR, 0, &pt, adr_rsc);
    return pt;
   }
 return 0;   
} 

/*--------------------------- Bload ------------------------------------*/
/* ACTION: Charge un fichier a l'adresse specifiee en entree.           */
/* ENTREE: char *path, path d'entree de la forme A:\PATH\               */
/*         char *nom, nom du fichier de la forme  NOM_FIC.EXT           */
/* SORTIE: adresse memoire situee apres le dernier octet charge.        */
/*         (si egale a l'adresse de chargement c'est qu'il il n'y a     */
/*          rien de charge donc erreur.)                                */
 
void  *Bload( char *path, char *name, void *adr_load)
  {char path_name[512]; /*chaine locale pour creer path+nom */
   INT16  f_hand;
   long  f_len=0;
   strcpy(path_name, path);
   if (name) strcat(path_name, name);     
   if ( (f_hand = (INT16) Fopen( path_name,FO_READ)) >= 0)
      {f_len = filelength(f_hand);
       Fread(f_hand,f_len,(char*)adr_load);
       Fclose (f_hand);
      } 
   return (void*) ((long)adr_load+f_len);
  }
  
/*------------------------- Bsave --------------------------------------*/
/* ACTION: Sauve dans un fichier dont le nom et le path sont specifies  */
/*         un bloc memoire situe  l'adresse adr_src et de longueur len */
/*         si le fichier existait auparavant, il est detruit.           */
/* ENTREE: char *path_in, path d'entree de la forme A:\PATH\            */
/*         char *nom_in, nom du fichier de la forme  NOM_FIC.EXT        */
/*         void *adr_src, adresse de la zone memoire a sauver.          */
/*         size_t len, longueur de memoire a sauver.                    */
/* SORTIE: long positif, tout est OK. (nbr d'octets lus)                */
/*         Negatif: -300 ce fichier existait deja et n'a pu etre efface */
/*                  -301 impossible d'ouvrir le fichier.                */
/*                  autres nbr. negatifs = GEMDOS ERROR                 */

long Bsave(char *path_in, char *nom_in, void *adr_src, size_t len)
{ char path[512];
  long err;
  INT16  f_hand;

  strcpy(path, path_in);
  if (nom_in) strcat(path, nom_in);
  /*............... effacer le fichier si il existe ................*/
  if (Fic_exist(path_in, nom_in)!= -1L && Fdelete(path)!=0)  return -300L;  
  f_hand=(INT16)Fcreate(path,0);
  if (f_hand < 0)                                            return -301L;  
  err = Fwrite(f_hand, (long)len, adr_src);
  Fclose(f_hand);
  return err;
}  

/*---------------------------- XYToScrollBoxItem -------------------------*/
/* ACTION: Retourne la ligne cliquee dans la SCROLLBOX.                   */
/* ENTREE: OBJECT *object, pointe sur le prem. objet de l'arbre d'objets  */
/*                         ou se trouve l'objet.                          */
/*         INT16 ob_ind, indice de l'objet SCROLLBOX clique dans cet arbre. */
/*         INT16 x, INT16 y, coordonnees X & Y de la souris                   */
/* SORTIE: long, ligne cliquee (option base 0) de la SCROLLBOX.           */

long XYToScrollBoxItem(OBJECT *object, INT16 ob_ind, INT16 x, INT16 y)
{INT16 d_h, nbr_lgn;
 long item;
 XSCROLLBLK *scrollboxblk;
 GRECT ob_grect;
 x++;  /* juste pour bloquer le warning     */
 ob_grect = *(GRECT*)&object[ob_ind].ob_x;
 objc_offset(object, ob_ind, &ob_grect.g_x, &ob_grect.g_y);
 scrollboxblk = (XSCROLLBLK*) object[ob_ind].ob_spec.userblk->ub_parm;
 nbr_lgn = (ob_grect.g_h-2) / scrollboxblk->LgnH; 
 d_h = (ob_grect.g_h - ( scrollboxblk->LgnH * nbr_lgn )) >>1;
 ob_grect.g_y += d_h;
 if (y > ob_grect.g_y)
    {item = scrollboxblk->FstLgn + (y - ob_grect.g_y) / scrollboxblk->LgnH;
    }   
 return item;
}

/*--------------------------- MakeEvntClicOnObjet ------------------------*/
/* ACTION: Modifie le flux evenementiel, represente par EVNT_O *Evnt, de  */
/*         maniere a simuler le click sur un objet dont les coordonnees   */
/*         sont donnees en entree.                                        */
/* ENTREE: OBJECT *object, pointe sur le prem. objet de l'arbre d'objets  */
/*                         ou se trouve l'objet.                          */
/*         INT16 ob_ind, indice de l'objet clique dans cet arbre.           */
/*         EVNT_O *Evnt, pointe sur la variable de flux evenementiel a    */
/*                       modifier.                                        */
/* SORTIE: EVNT_O *, pointe sur la variable de flux evenementiel modifiee */

EVNT_O *MakeEvntClicOnObjet(OBJECT *object, INT16 ob_ind, EVNT_O *Evnt)
{objc_offset(object, ob_ind, &Evnt->x, &Evnt->y);
 Evnt->evnt |= MU_BUTTON;
 Evnt->x +=  object[ob_ind].ob_width>>1;
 Evnt->y +=  object[ob_ind].ob_height>>1;
 Evnt->k  = 1;
 return Evnt;
}

/*---------------------- CreateModalWindow -----------------------------*/
/* ACTION: cet appel est le meme que create window, a la difference     */
/*         qu'apres cet appel la main n'est rendue qu'apres fermeture   */
/*         de la fenetre. Lors de cet appel les autres fenetres, et le  */
/*         menu ne sont plus accessibles.                               */

INT16  CreateModalWindow ( long w_attr,                                     
                    INT16 ident,                                         
                    void *adr,                                                        
                    CALLBACK (*w_proc)(INT16 w_ind, EVNT_O *Evnt),                          
                    INT16 x, INT16 y, INT16 w, INT16 h,                       
                    char *nom                                         
                  )  
{INT16 modal_wh, sav_modal_wind;
 w_attr |= XMODAL; 
 modal_wh = CreateWindow(w_attr,ident, adr, w_proc, x,y,w,h, nom);
 if (modal_wh>0)
    {sav_modal_wind = ModalWind;
     ModalWind = IdentToIndice(ident);
     BoucleModale(0L,0L);
     ModalWind = sav_modal_wind;      
    }
 return modal_wh;   
}

/*---------------------- OpenModalWindow -----------------------------------------*/
/* ACTION: cet appel est le meme que OpenWindow, a la difference                  */
/*         qu'apres cet appel la main n'est rendue qu'apres fermeture             */
/*         de la fenetre. Lors de cet appel les autres fenetres, et le            */
/*         menu ne sont plus accessibles.                                         */
/* ENTREE: INT16 w_ind:                                                             */
/*             indice EAZY_GEM de la fenetre (pointe sur tableau Windtab[w_ind]   */
/*             correspondant  cette fenetre.                                     */ 
/*         GRECT* grectb: coordonnees externes d'ouverture de la fenetre.         */
/*                si ZERO le rectangle: Windtab[w_ind].ExtGrectUse de la fenetre  */
/*                                      sera utilise                              */
/* RETOUR: INT16: si 1/ouverture en full size  car coordonnes trop grandes.        */ 
/*                 0/ouverture selon coordonnes d'entre.                        */

INT16  OpenModalWindow (INT16 w_ind, GRECT* grectb)
{INT16 sav_modal_wind,i;
 Windtab[w_ind].w_attr |= XMODAL; 
 if (grectb==0) grectb = &Windtab[w_ind].ExtGrectUse; 
 i              = OpenWindow( w_ind, grectb);
 sav_modal_wind = ModalWind;
 ModalWind      = w_ind;
 BoucleModale(0L,0L);
 ModalWind      = sav_modal_wind;      
 return i;   
}
/*-----------------------  Wobjc_draw ------------------------------*/
/* ACTION: redessine l'objet place en entree, en tenant compte de   */
/*         la liste des rectangles.                                 */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de LA fenetre.                */
/*         OBJECT *object, adresse arbre auquel appartient l'objet. */
/*         INT16 num_ob, numro de l'objet dans cet arbre.            */
/*         INT16 niveau, profondeur de redessin dans la descendance   */
/*         GRECT *clipgrect, rectangle de clipping.                 */
/*                si il est non defini (==0), c'est le rectangle de */
/*                de l'objet qui est utilis.                       */
/* RETOUR: INT16 code erreur.                                         */

INT16 Wobjc_draw(INT16 w_ind, OBJECT *object, INT16 num_ob, INT16 niveau, GRECT *clip_grect)
{GRECT grect,r1; 
 INT16 res;
 INT16 w_h  = Windtab[w_ind].w_h;
 /* INT16   f  = 0; */     /* flag si positionne il n'est dessine que l'objet sans ceux sous jacents */
 /*if (clip_grect==(GRECT*)1L) f=1;                  */
 /* if (clip_grect>=0 && clip_grect <(GRECT*) 5L)    */     /* si le rectangle de clipping non defini, on prend  */
 if (clip_grect==0 )
    {INT16 wframe = GetFrameWidth(object, num_ob);
     clip_grect = &grect;   /* celui de l'objet                                  */
     objc_offset( object, num_ob, &grect.g_x,  &grect.g_y );
     grect.g_x += wframe;
     grect.g_y += wframe;
     grect.g_w = object[num_ob].ob_width  - wframe*2 + 2;
     grect.g_h = object[num_ob].ob_height - wframe*2 + 2;
     if (GET_XOBTYPE(object,num_ob) == G_CICON) num_ob = 0; 
    }

 wind_get( w_h, WF_FIRSTXYWH, &r1.g_x, &r1.g_y, &r1.g_w, &r1.g_h);
 while (r1.g_w && r1.g_h)
   {if ( Rc_intersect( clip_grect, &r1)) 
       {/*.......... on dessine l'objet directement sans les sous jacents ............*/
        /* a ne marche pas de dessiner directement a partir de l'adresse de l'objet !!!
        if (f) res = objc_draw( &object[num_ob], 0, niveau,  r1.g_x, r1.g_y, r1.g_w, r1.g_h); 
        */
        /*.......... on dessine l'objet avec les sous jacents ........................*/
        if (niveau==-1) res = objc_draw( object, 0, 20,  r1.g_x, r1.g_y, r1.g_w, r1.g_h);
        else            res = objc_draw( object, num_ob, niveau,  r1.g_x, r1.g_y, r1.g_w, r1.g_h);
       } 
    wind_get(w_h, WF_NEXTXYWH, &r1.g_x, &r1.g_y, &r1.g_w, &r1.g_h);
   }  
 return res;
}

/*---------------------------- WSetCursObEditOff-------------------------------*/
/* ACTION: eteint le curseur texte des champs editables en tenant compte de    */
/*         la liste des rectangles.                                            */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre.                           */
/*         GRECT *clipgrect, rectangle de clipping.                            */
/*                si il est non defini (==0), c'est le rectangle de            */
/*                de l'objet qui est utilis.                                  */

void WSetCursObEditOff(INT16 w_ind, GRECT *clip_grect)
{GRECT grect,r1;   
 DLG_VAR *dlg   = &Windtab[w_ind].DlgVar;
 OBJECT *object = GETWINDTREE(w_ind);
 INT16 w_h        = Windtab[w_ind].w_h;
 INT16 num_ob     = dlg->ObjEdit;
 
if (num_ob > -1 &&            /* si editable        */
    dlg->CurState             /* si allum eteindre */
   )
   {if (clip_grect==0)         /* si le rectangle de clipping non defini, on prend  */
       {clip_grect = &grect;   /* celui de l'objet                                  */
        objc_offset( object, num_ob, &grect.g_x,  &grect.g_y );
        grect.g_x -=2;
        grect.g_y -=2;
        grect.g_w = object[num_ob].ob_width  + 4;
        grect.g_h = object[num_ob].ob_height + 4;
       }
 
    wind_get( w_h, WF_FIRSTXYWH, &r1.g_x, &r1.g_y, &r1.g_w, &r1.g_h);
    while (r1.g_w && r1.g_h)
      {if ( Rc_intersect( clip_grect, &r1)) 
          {ClipGrect(&r1);
           DrawEditableCursor(dlg->tree, num_ob, dlg->PosCursX);
          } 
       wind_get(w_h, WF_NEXTXYWH, &r1.g_x, &r1.g_y, &r1.g_w, &r1.g_h);
      }
    Mouse_on();
    dlg->CurState = 0;   
   }     
}     

/*---------------------------- WSetCursObEditOn -------------------------------*/
/* ACTION: Allume le curseur texte des champs editables en tenant compte de    */
/*         la liste des rectangles.                                            */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre.                           */
/*         GRECT *clipgrect, rectangle de clipping.                            */
/*                si il est non defini (==0), c'est le rectangle de            */
/*                de l'objet qui est utilis.                                  */

void WSetCursObEditOn(INT16 w_ind, GRECT *clip_grect)
{GRECT grect,r1;  
 DLG_VAR *dlg   = &Windtab[w_ind].DlgVar;
 OBJECT *object = GETWINDTREE(w_ind);
 INT16 w_h        = Windtab[w_ind].w_h;
 INT16 num_ob     = dlg->ObjEdit;
 
if (num_ob > -1 &&            /* si editable          */
    ! dlg->CurState           /* si eteint allumer   */
   )
   {if (clip_grect==0)         /* si le rectangle de clipping non defini, on prend  */
       {clip_grect = &grect;   /* celui de l'objet                                  */
        objc_offset( object, num_ob, &grect.g_x,  &grect.g_y );
        grect.g_x -=2;
        grect.g_y -=2;
        grect.g_w = object[num_ob].ob_width  + 4;
        grect.g_h = object[num_ob].ob_height + 4;        
       }
 
    wind_get( w_h, WF_FIRSTXYWH, &r1.g_x, &r1.g_y, &r1.g_w, &r1.g_h);
    while (r1.g_w && r1.g_h)
      {if ( Rc_intersect( clip_grect, &r1)) 
          {ClipGrect(&r1);
           DrawEditableCursor(dlg->tree, num_ob, dlg->PosCursX);
          } 
       wind_get(w_h, WF_NEXTXYWH, &r1.g_x, &r1.g_y, &r1.g_w, &r1.g_h);
      }
    Mouse_on();
    dlg->CurState = 1;   
   }     
}     

 
/*------------------------------ XYToListBoxItem -------------------------------*/
/* ACTION: si une listbox est ouverte dans la fenetre, il est recherche l'item  */
/*         pointe par la souris.                                                */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre contenant la LISTBOX        */
/*         INT16 x, INT16 y: position de la souris.                                 */
/* RETOUR: INT16: si -1 pas d'item pointe, si >=0 item point dans liste.         */

INT16 XYToListBoxItem( INT16 w_ind, INT16 x, INT16 y)
{INT16 ob_lstbox;
 INT16 item = -1; 
 GRECT ob_grect;
 XUSERBLK *xuserblk;
 OBJECT *object;
 DLG_VAR *dlg;
 
 x++; 
 dlg = &Windtab[w_ind].DlgVar; 
 object     = dlg->tree;
 ob_lstbox  = (INT16)dlg->LstAdr;
 if (ob_lstbox)
    {xuserblk = (XUSERBLK*) object[ob_lstbox].ob_spec.userblk->ub_parm; 
     objc_offset(object, ob_lstbox, &ob_grect.g_x, &ob_grect.g_y); 
     if (y > ob_grect.g_y + xuserblk->LstBoxHlign)
         item = xuserblk->BlkDeb + (y - ob_grect.g_y) / xuserblk->LstBoxHlign - 1;   
     else 
         item = xuserblk->LstBoxSel;      
    }
 return item;   
}

/*------------------------ Scroll_window -------------------------------*/
/* ACTION: fait scroller le rectangle de fenetre specifie, et redessine */
/*         en faisant appel  la fonction de fenetre, la partie         */
/*         decouverte.                                                  */
/* ENTREE: INT16 w_ind: indice EAZY_GEM de la fenetre dont il faut faire  */
/*                    sroller une partie.                               */
/*         GRECT *scrol_grect: coordonnes de la zone rectangulaire a   */
/*                             faire scroller.                          */
/*         INT16 dir: egal  HORIZONTAL, VERTICAL (sens de scrolling).    */
/*         long delta: quantite  faire scroller si  <0 dans un sens,   */
/*                     si >0 dans l'autre.                              */ 

void Scroll_window (INT16 w_ind, GRECT *scrol_grect, INT16 dir, long delta)
{INT16 draw = FALSE;
 INT16 w_h  = GETGEMHAND(w_ind);
 MFDB s, d;
 INT16 xy[8];
 GRECT r,desk;
 
 wind_get (w_h, WF_FIRSTXYWH, &r.g_x, &r.g_y, &r.g_w, &r.g_h);
 desk.g_x = desk.g_y = 0;
 desk.g_w = Ecran_l;
 desk.g_h = Ecran_h;
 
 r = *scrol_grect;
 if (!Rc_intersect(&desk,&r)) return;

 if (dir & HORIZONTAL)
    {if (labs(delta) >= r.g_w)  draw = TRUE;
    }
 else
    {if (labs(delta) >= r.g_h)  draw = TRUE;
    }

 if (!draw)
    {GRECT_to_VRECT (&r, (VRECT*)xy);      /* Quelle fr vro_cpyfm */
     xy[4] = xy[0];        /* Ziel fr vro_cpyfm */
     xy[5] = xy[1];
     xy[6] = xy[2];
     xy[7] = xy[3];
      /*.............. SCROLLING HORIZONTAL ................*/   
     if (dir & HORIZONTAL)      /* Horizontales Scrolling */
        {if (delta > 0)       /* Links Scrolling */
            {xy[0] += (short) delta;   /* Werte fr vro_cpyfm */
             xy[6] -= (short) delta;

             r.g_x += r.g_w - (short)delta;  /* Rechter Bereich nicht gescrollt, */
             r.g_w  = (short)delta;    /* mu neu gezeichnet werden */
            }
         else          /* Rechts Scrolling */
            {xy[2] += (short)delta;   /* Werte fr vro_cpyfm */
             xy[4] -= (short)delta;

             r.g_w = (short)(-delta);   /* Linken Bereich noch neu zeichnen */
            }
        }
     /*.............. SCROLLING VERTICAL ...................*/   
     else           
        {if (delta > 0)       /* Aufwrts Scrolling */
            {xy[1] += (short)delta;     /* Werte fr vro_cpyfm */
             xy[7] -= (short)delta;

             r.g_y += r.g_h - (short)delta;     /* Unterer Bereich nicht gescrollt, */
             r.g_h  = (short) delta;      /* mu neu gezeichnet werden */
            }
         else          /* Abwrts Scrolling */
            {xy[3] += (short)delta;     /* Werte fr vro_cpyfm */
             xy[5] -= (short)delta;

             r.g_h = (short)(-delta);     /* Oberen Bereich noch neu zeichnen */
            }
        }
     s.fd_addr = d.fd_addr = NULL;   /* Erzwinge Bildschirmadresse */
     vs_clip( VDIhandle, FALSE, xy );
     Mouse_off ();
     vro_cpyfm (VDIhandle, S_ONLY, xy, &s, &d);
     Mouse_on ();
     
     r.g_x -= 2;     
     r.g_y -= 1;     
     r.g_w += 4;     
     r.g_h += 2;     
     
     Lister_rectangles(w_h, &r);
    }
 else 
    {Lister_rectangles(w_h, &r);
    }
} /* scroll_window */

/*---------------------------- SlidePosToDocPos ------------------------*/
/* ACTION: calcul de la nouvelle position document  partir de la       */
/*         position souris sur l'assenceur.                             */
/* ENTREE: OBJECT *object, INT16 ob_Vbar objet de type SLIDEBAR c.a.d.    */
/*         barre de scroll avec en fils un assenceur (slide)            */
/*         unsigned long doc_total, taille totale du document.          */
/*         unsigned long doc_view, taille representable du document dans*/
/*                                 la fenetre de visualisation.         */
/*         unsigned long doc_pos, ofset d'affichage du document par     */
/*                                rapport a son debut.(en fait c'est le */
/*                                premier element affich).             */  
/*         INT16 pos_mouse,         position de la souris.                */
/*         INT16 scrolcoef,  coefficient de scrolling minimum.            */
/*         INT16 mode, HORIZONTAL ou VERTICAL indique le type de barre de */
/*                   SLIDEBAR a laquelle l'on a affaire.                */
/* RETOUR: un long qui la nouvelle position document.                   */

long SlidePosToDocPos(OBJECT *object, INT16 ob_Vbar,
                      unsigned long doc_total, 
                      unsigned long doc_view,
                      unsigned long doc_pos, 
                      INT16 pos_mouse,
                      INT16 scrolcoef,
                      INT16 mode)
{INT16 ob_Vasc = -1;
 long d;
 INT16 bar_width, slide_width, slide_pos, ob_x, ob_y;
 if (ob_Vbar==-1)   return 0;
 if (mode==HORIZONTAL) ob_Vasc = FindObTypeInParentAndFreres(object, object[ob_Vbar].ob_head,  USER_SH_AS<<8);
 else                  ob_Vasc = FindObTypeInParentAndFreres(object, object[ob_Vbar].ob_head,  USER_SV_AS<<8);
 if (ob_Vasc==-1)      ob_Vasc = object[ob_Vbar].ob_head;
 
 if (ob_Vasc > -1)  
    {objc_offset( object, ob_Vasc, &ob_x,  &ob_y );
     if (mode==HORIZONTAL) 
        {bar_width   = object[ob_Vbar].ob_width;
         slide_width = object[ob_Vasc].ob_width;
         slide_pos   = ob_x;
        }
     else
        {bar_width    = object[ob_Vbar].ob_height;
         slide_width  = object[ob_Vasc].ob_height;
         slide_pos    = ob_y;
        } 
     d = pos_mouse - slide_pos - ( slide_width >>1 );
     d = ((double)d * (double)(doc_total - doc_view)) / (bar_width - slide_width);  
      
     if (labs(d) >= scrolcoef)
        {d = (d / scrolcoef) * scrolcoef;
         doc_pos = Min( doc_total - doc_view , doc_pos + d );
         doc_pos = Max(0, doc_pos);
         return doc_pos;
        }
  }      
  return 0;
}        

/*---------------------------- SetSlideWidth ---------------------------*/
/* ACTION: calcul de la largeur d'un assenceur  partir des donnes du   */
/*         document.                                                    */
/* ENTREE: OBJECT *object, INT16 ob_Vbar objet de type SLIDEBAR c.a.d.    */
/*         barre de scroll avec en fils un assenceur (slide)            */
/*         unsigned long doc_total, taille totale du document.          */
/*         unsigned long doc_view, taille representable du document dans*/
/*                                 la fenetre de visualisation.         */
/*         unsigned long doc_pos, ofset d'affichage du document par     */
/*                                rapport a son debut.(en fait c'est le */
/*                                premier element affich).             */  
/*         INT16 min_slide,  taille minimum de l'assenceur.               */
/*         INT16 mode, HORIZONTAL ou VERTICAL indique le type de barre de */
/*                   SLIDEBAR a laquelle l'on a affaire.                */
/* RETOUR: un long qui la nouvelle position document.                   */

long SetSlideWidth(OBJECT *object, INT16 ob_Vbar, 
                  unsigned long doc_total, 
                  unsigned long doc_view, 
                  unsigned long doc_pos,
                  INT16 min_slide,
                  INT16 mode)
{INT16 ob_Vasc = -1;
 INT16 slide_pos;
 INT16 bar_width, slide_width;
 if (ob_Vbar==-1)   return -1L;
 if (mode==HORIZONTAL) ob_Vasc = FindObTypeInParentAndFreres(object, object[ob_Vbar].ob_head,  USER_SH_AS<<8);
 else                  ob_Vasc = FindObTypeInParentAndFreres(object, object[ob_Vbar].ob_head,  USER_SV_AS<<8);
 if (ob_Vasc==-1)      ob_Vasc = object[ob_Vbar].ob_head;
 if (ob_Vasc > -1)  
    {if (mode==HORIZONTAL) 
        {bar_width   = object[ob_Vbar].ob_width;
         slide_width = object[ob_Vasc].ob_width;
         slide_pos   = object[ob_Vasc].ob_x;
        }
     else
        {bar_width    = object[ob_Vbar].ob_height;
         slide_width  = object[ob_Vasc].ob_height;
         slide_pos    = object[ob_Vasc].ob_y;
        }  
     slide_width = Min( bar_width,
                        Max((double)((double)bar_width * (double)doc_view) 
                                     / doc_total,
                             min_slide
                            )
                      ); 
     slide_pos = Min( bar_width - slide_width, slide_pos);
     slide_pos = Max(0, slide_pos);
        
     doc_pos = ((double)slide_pos * (double)(doc_total - doc_view)) /
                   (bar_width - slide_width); 
                                  
     doc_pos = Max (0, Min (doc_total - doc_view, doc_pos));
     if (mode==HORIZONTAL) 
        {object[ob_Vasc].ob_width = slide_width;
         object[ob_Vasc].ob_x     = slide_pos;
        }
     else
        {object[ob_Vasc].ob_height = slide_width;
         object[ob_Vasc].ob_y      = slide_pos;         
        } 
     return doc_pos;
    }
 return -1L;
} 
   
 
/*---------------------------- DocPosToSlidePos ------------------------*/
/* ACTION: calcul de la position d'un assenceur  partir des donnes du  */
/*         document.                                                    */
/* ENTREE: OBJECT *object, INT16 ob_Vbar objet de type SLIDEBAR c.a.d.    */
/*         barre de scroll avec en fils un assenceur (slide)            */
/*         unsigned long doc_total, taille totale du document.          */
/*         unsigned long doc_view, taille representable du document dans*/
/*                                 la fenetre de visualisation.         */
/*         unsigned long doc_pos, ofset d'affichage du document par     */
/*                                rapport a son debut.(en fait c'est le */
/*                                premier element affich).             */  
/*         INT16 mode, HORIZONTAL ou VERTICAL indique le type de barre de */
/*                   SLIDEBAR a laquelle l'on a affaire.                */
/* RETOUR: un INT16 qui le nombre de pixels dont s'est deplace            */
/*         l'ascenseur                                                  */  
                     
INT16 DocPosToSlidePos(OBJECT *object, INT16 ob_Vbar,                     
                     unsigned long doc_total, 
                     unsigned long doc_view,
                     unsigned long doc_pos, 
                     INT16 mode)
{double pos;
 INT16 old_pos;
 INT16 bar_width, slide_width;
 INT16 ob_Vasc = -1;
 if (ob_Vbar==-1)   return -1;
 if (mode==HORIZONTAL) ob_Vasc = FindObTypeInParentAndFreres(object, object[ob_Vbar].ob_head,  USER_SH_AS<<8);
 else                  ob_Vasc = FindObTypeInParentAndFreres(object, object[ob_Vbar].ob_head,  USER_SV_AS<<8);
 if (ob_Vasc==-1)      ob_Vasc = object[ob_Vbar].ob_head;
 if (ob_Vasc > -1)  
    {if (mode==HORIZONTAL) 
        {old_pos     = object[ob_Vasc].ob_x;
         bar_width   = object[ob_Vbar].ob_width;
         slide_width = object[ob_Vasc].ob_width;
        }
     else
        {old_pos      = object[ob_Vasc].ob_y;
         bar_width    = object[ob_Vbar].ob_height;
         slide_width  = object[ob_Vasc].ob_height;
        }              
     pos = (double) (bar_width - slide_width)  *
           (double) doc_pos;                                      
     pos = pos / (double)(doc_total - doc_view);
     if (mode==HORIZONTAL) object[ob_Vasc].ob_x = (INT16)pos;         
     else                  object[ob_Vasc].ob_y = (INT16)pos;
     return (INT16)pos - old_pos; 
    }
 return -1;
}
