EXPORT Timer
EXPORT EZ_OutText
EXPORT EZ_VDIPB
EXPORT EZcontrl
EXPORT EZintin
EXPORT EZptsin
EXPORT EZintout
EXPORT EZptsout

IMPORT vdi_intin 
IMPORT vdi_intout
IMPORT vdi_ptsin
IMPORT vdi_ptsout
IMPORT vdi_control
IMPORT EZ_VDIPB
TEXT

;------------------------- EZ_OutText ------------------------------------------
; ACTION: implementation de EZ_OutText() pour tableaux de caracteres de 1024
;         affiche une chaine de caractres pouvant faire 1024 caractres et
;         retourne les dimmensions de a chaine affiche
;         le mode de justification verticale doit etre Baseline.
; ENTREE: D0.W:   VDIhandle
;         D1.W:   position x d'affichage
;         D2.W:   position y d'affichage du sommet de la chaine 
;                 (ci-dessoue y est ajout sa  hauteur afin que l'affichage en
;                  0/0 de la baseline soit visible)
;         A0:     adresse de la chaine de caracteres
;         A1:     adresse du tableau de dimmensions  remplir (8 short)
; SORTIE: largeur de la chaine affiche
; APPELC: prototype C   -> int EZ_OutText(int vdi_handle, int x, int y, char *str);

EZ_OutText:
                 MOVEM.W D1-D2,vdi_ptsin    ; on place x & y en ptsin                            24
                 MOVE.L #vdi_intin, A1      ; A1 = INTIN                                         12
                 MOVE.L  A0,D2             ;stocker adresse initiale de la chaine
                 MOVEQ.L #$00,D1           ;buffer de caractere char->short
                 BRA.B   IN_BCLE_f_extent
_BCLE_f_extent:   
                 MOVE.W   D1,(A1)+
IN_BCLE_f_extent:
                 MOVE.B  (A0)+,D1
                 BNE.B   _BCLE_f_extent
                 ADDQ  #1,D2               ; car 1 de trop
                 SUBA.L  D2,A0             ;nombre de caractres placs
                 
        MOVE.L #vdi_control,A1  ;                                                                12
        MOVE    D0,12(A1)      ;Handle VDI.
        MOVE    A0,6(A1)       ;nbr intin len str (nbr de car)
        MOVE.L #$00F00000,(A1) ;opcode vqt_f_extent F0 + nbr de ptsin couples x&y
        ;..... allez pour vdi......
        MOVE.L #EZ_VDIPB,D1 ;~~~VDI~~~
        MOVEQ #$73,D0
        TRAP #2
         
        MOVE.L #vdi_ptsout, A0            ;                                                      12
        MOVE.W 10(A0),D0                  ; recuperer Hauteur
        ADD.W   D0, vdi_ptsin+2           ; additionner  la position y d'affichage
        MOVE.W 8(A0),-(A7)                ; recuperer Largeur  et la sauver                      16
        MOVE.L #$00F10001, vdi_control    ; Placer Opcode v_ftext et nbr de ptsin                28
        ;..... allez pour vdi......
        MOVE.L #EZ_VDIPB,D1 ;~~~VDI~~~
        MOVEQ #$73,D0
        TRAP #2
        MOVE.W (A7)+,D0                   ;retourner largeur
        RTS
        

;------------------------- Timer --------------------------------------------
; ACTION: retourne le temps ecoul depuis l'allumage de l'ordinateur
; ENTREE: Neant
; SORTIE: D0.L = temps coul en milisecondes 
; APPELC: prototype  C  -> long Timer(void);
;         utilisation   -> temps=Timer();

Timer:
   PEA timespexec(PC)
   MOVE.W #$26,-(A7)
   TRAP #14
   ADDQ.L #6,A7
   RTS
timespexec:
   MOVE.L $4BA,D0
  RTS


